///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /    Vendor: Xilinx
// \   \   \/     Version : 1.7
//  \   \         Application : Spartan-6 FPGA GTP Transceiver Wizard
//  /   /         Filename : ser16.v
// /___/   /\     Timestamp :
// \   \  /  \ 
//  \___\/\___\
//
//
// Module SER16 (a GTP Wrapper)
// Generated by Xilinx Spartan-6 FPGA GTP Transceiver Wizard
// 
// 
// (c) Copyright 2009 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES. 



`timescale 1ns / 1ps


//***************************** Entity Declaration ****************************
(* CORE_GENERATION_INFO = "SER16,s6_gtpwizard_v1_5,{gtp0_protocol_file=Start_from_scratch,gtp1_protocol_file=Use_GTP0_settings}" *)
module SER16 #
(
    // Simulation attributes
    parameter   WRAPPER_SIM_GTPRESET_SPEEDUP    = 0,    // Set to 1 to speed up sim reset
    parameter   WRAPPER_CLK25_DIVIDER_0         = 10,
    parameter   WRAPPER_CLK25_DIVIDER_1         = 10,
    parameter   WRAPPER_PLL_DIVSEL_FB_0         = 2,
    parameter   WRAPPER_PLL_DIVSEL_FB_1         = 2,
    parameter   WRAPPER_PLL_DIVSEL_REF_0        = 1,
    parameter   WRAPPER_PLL_DIVSEL_REF_1        = 1,
 
    parameter   WRAPPER_SIMULATION              = 0     // Set to 1 for simulation
)
(
    
    //_________________________________________________________________________
    //_________________________________________________________________________
    //TILE0  (X0_Y0)

 
    //---------------------- Loopback and Powerdown Ports ----------------------
    input   [2:0]   TILE0_LOOPBACK0_IN,
    input   [2:0]   TILE0_LOOPBACK1_IN,
    //------------------------------- PLL Ports --------------------------------
    input           TILE0_CLK00_IN,
    input           TILE0_CLK01_IN,
    input           TILE0_GTPRESET0_IN,
    input           TILE0_GTPRESET1_IN,
    output          TILE0_PLLLKDET0_OUT,
    output          TILE0_RESETDONE0_OUT,
    output          TILE0_RESETDONE1_OUT,
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    output  [1:0]   TILE0_RXDISPERR0_OUT,
    output  [1:0]   TILE0_RXDISPERR1_OUT,
    output  [1:0]   TILE0_RXNOTINTABLE0_OUT,
    output  [1:0]   TILE0_RXNOTINTABLE1_OUT,
    //--------------------- Receive Ports - PRBS Detection ---------------------
    input           TILE0_PRBSCNTRESET0_IN,
    input           TILE0_PRBSCNTRESET1_IN,
    input   [2:0]   TILE0_RXENPRBSTST0_IN,
    input   [2:0]   TILE0_RXENPRBSTST1_IN,
    output          TILE0_RXPRBSERR0_OUT,
    output          TILE0_RXPRBSERR1_OUT,
    //----------------- Receive Ports - RX Data Path interface -----------------
    output  [15:0]  TILE0_RXDATA0_OUT,
    output  [15:0]  TILE0_RXDATA1_OUT,
    output          TILE0_RXRECCLK0_OUT,
    output          TILE0_RXRECCLK1_OUT,
    input           TILE0_RXUSRCLK0_IN,
    input           TILE0_RXUSRCLK1_IN,
    input           TILE0_RXUSRCLK20_IN,
    input           TILE0_RXUSRCLK21_IN,
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    input   [1:0]   TILE0_RXEQMIX0_IN,
    input   [1:0]   TILE0_RXEQMIX1_IN,
    input           TILE0_RXN0_IN,
    input           TILE0_RXN1_IN,
    input           TILE0_RXP0_IN,
    input           TILE0_RXP1_IN,
    //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    input           TILE0_RXENPMAPHASEALIGN0_IN,
    input           TILE0_RXENPMAPHASEALIGN1_IN,
    input           TILE0_RXPMASETPHASE0_IN,
    input           TILE0_RXPMASETPHASE1_IN,
    //-------------------------- TX/RX Datapath Ports --------------------------
    output  [1:0]   TILE0_GTPCLKFBEAST_OUT,
    output  [1:0]   TILE0_GTPCLKFBWEST_OUT,
    output  [1:0]   TILE0_GTPCLKOUT0_OUT,
    output  [1:0]   TILE0_GTPCLKOUT1_OUT,
    //----------------- Transmit Ports - 8b10b Encoder Control -----------------
    input   [1:0]   TILE0_TXCHARISK0_IN,
    input   [1:0]   TILE0_TXCHARISK1_IN,
    //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    input           TILE0_TXENPMAPHASEALIGN0_IN,
    input           TILE0_TXENPMAPHASEALIGN1_IN,
    input           TILE0_TXPMASETPHASE0_IN,
    input           TILE0_TXPMASETPHASE1_IN,
    //---------------- Transmit Ports - TX Data Path interface -----------------
    input   [15:0]  TILE0_TXDATA0_IN,
    input   [15:0]  TILE0_TXDATA1_IN,
    output          TILE0_TXOUTCLK0_OUT,
    output          TILE0_TXOUTCLK1_OUT,
    input           TILE0_TXUSRCLK0_IN,
    input           TILE0_TXUSRCLK1_IN,
    input           TILE0_TXUSRCLK20_IN,
    input           TILE0_TXUSRCLK21_IN,
    //------------- Transmit Ports - TX Driver and OOB signalling --------------
    output          TILE0_TXN0_OUT,
    output          TILE0_TXN1_OUT,
    output          TILE0_TXP0_OUT,
    output          TILE0_TXP1_OUT,
    //------------------- Transmit Ports - TX PRBS Generator -------------------
    input   [2:0]   TILE0_TXENPRBSTST0_IN,
    input   [2:0]   TILE0_TXENPRBSTST1_IN,


    
    //_________________________________________________________________________
    //_________________________________________________________________________
    //TILE1  (X1_Y0)

 
    //---------------------- Loopback and Powerdown Ports ----------------------
    input   [2:0]   TILE1_LOOPBACK0_IN,
    input   [2:0]   TILE1_LOOPBACK1_IN,
    //------------------------------- PLL Ports --------------------------------
    input           TILE1_CLK00_IN,
    input           TILE1_CLK01_IN,
    input           TILE1_GTPRESET0_IN,
    input           TILE1_GTPRESET1_IN,
    output          TILE1_PLLLKDET0_OUT,
    output          TILE1_RESETDONE0_OUT,
    output          TILE1_RESETDONE1_OUT,
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    output  [1:0]   TILE1_RXDISPERR0_OUT,
    output  [1:0]   TILE1_RXDISPERR1_OUT,
    output  [1:0]   TILE1_RXNOTINTABLE0_OUT,
    output  [1:0]   TILE1_RXNOTINTABLE1_OUT,
    //--------------------- Receive Ports - PRBS Detection ---------------------
    input           TILE1_PRBSCNTRESET0_IN,
    input           TILE1_PRBSCNTRESET1_IN,
    input   [2:0]   TILE1_RXENPRBSTST0_IN,
    input   [2:0]   TILE1_RXENPRBSTST1_IN,
    output          TILE1_RXPRBSERR0_OUT,
    output          TILE1_RXPRBSERR1_OUT,
    //----------------- Receive Ports - RX Data Path interface -----------------
    output  [15:0]  TILE1_RXDATA0_OUT,
    output  [15:0]  TILE1_RXDATA1_OUT,
    output          TILE1_RXRECCLK0_OUT,
    output          TILE1_RXRECCLK1_OUT,
    input           TILE1_RXUSRCLK0_IN,
    input           TILE1_RXUSRCLK1_IN,
    input           TILE1_RXUSRCLK20_IN,
    input           TILE1_RXUSRCLK21_IN,
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    input   [1:0]   TILE1_RXEQMIX0_IN,
    input   [1:0]   TILE1_RXEQMIX1_IN,
    input           TILE1_RXN0_IN,
    input           TILE1_RXN1_IN,
    input           TILE1_RXP0_IN,
    input           TILE1_RXP1_IN,
    //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    input           TILE1_RXENPMAPHASEALIGN0_IN,
    input           TILE1_RXENPMAPHASEALIGN1_IN,
    input           TILE1_RXPMASETPHASE0_IN,
    input           TILE1_RXPMASETPHASE1_IN,
    //-------------------------- TX/RX Datapath Ports --------------------------
    output  [1:0]   TILE1_GTPCLKFBEAST_OUT,
    output  [1:0]   TILE1_GTPCLKFBWEST_OUT,
    output  [1:0]   TILE1_GTPCLKOUT0_OUT,
    output  [1:0]   TILE1_GTPCLKOUT1_OUT,
    //----------------- Transmit Ports - 8b10b Encoder Control -----------------
    input   [1:0]   TILE1_TXCHARISK0_IN,
    input   [1:0]   TILE1_TXCHARISK1_IN,
    //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    input           TILE1_TXENPMAPHASEALIGN0_IN,
    input           TILE1_TXENPMAPHASEALIGN1_IN,
    input           TILE1_TXPMASETPHASE0_IN,
    input           TILE1_TXPMASETPHASE1_IN,
    //---------------- Transmit Ports - TX Data Path interface -----------------
    input   [15:0]  TILE1_TXDATA0_IN,
    input   [15:0]  TILE1_TXDATA1_IN,
    output          TILE1_TXOUTCLK0_OUT,
    output          TILE1_TXOUTCLK1_OUT,
    input           TILE1_TXUSRCLK0_IN,
    input           TILE1_TXUSRCLK1_IN,
    input           TILE1_TXUSRCLK20_IN,
    input           TILE1_TXUSRCLK21_IN,
    //------------- Transmit Ports - TX Driver and OOB signalling --------------
    output          TILE1_TXN0_OUT,
    output          TILE1_TXN1_OUT,
    output          TILE1_TXP0_OUT,
    output          TILE1_TXP1_OUT,
    //------------------- Transmit Ports - TX PRBS Generator -------------------
    input   [2:0]   TILE1_TXENPRBSTST0_IN,
    input   [2:0]   TILE1_TXENPRBSTST1_IN,


    
    //_________________________________________________________________________
    //_________________________________________________________________________
    //TILE2  (X0_Y1)

 
    //---------------------- Loopback and Powerdown Ports ----------------------
    input   [2:0]   TILE2_LOOPBACK0_IN,
    input   [2:0]   TILE2_LOOPBACK1_IN,
    //------------------------------- PLL Ports --------------------------------
    input           TILE2_CLK00_IN,
    input           TILE2_CLK01_IN,
    input           TILE2_GTPRESET0_IN,
    input           TILE2_GTPRESET1_IN,
    output          TILE2_PLLLKDET0_OUT,
    output          TILE2_RESETDONE0_OUT,
    output          TILE2_RESETDONE1_OUT,
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    output  [1:0]   TILE2_RXDISPERR0_OUT,
    output  [1:0]   TILE2_RXDISPERR1_OUT,
    output  [1:0]   TILE2_RXNOTINTABLE0_OUT,
    output  [1:0]   TILE2_RXNOTINTABLE1_OUT,
    //--------------------- Receive Ports - PRBS Detection ---------------------
    input           TILE2_PRBSCNTRESET0_IN,
    input           TILE2_PRBSCNTRESET1_IN,
    input   [2:0]   TILE2_RXENPRBSTST0_IN,
    input   [2:0]   TILE2_RXENPRBSTST1_IN,
    output          TILE2_RXPRBSERR0_OUT,
    output          TILE2_RXPRBSERR1_OUT,
    //----------------- Receive Ports - RX Data Path interface -----------------
    output  [15:0]  TILE2_RXDATA0_OUT,
    output  [15:0]  TILE2_RXDATA1_OUT,
    output          TILE2_RXRECCLK0_OUT,
    output          TILE2_RXRECCLK1_OUT,
    input           TILE2_RXUSRCLK0_IN,
    input           TILE2_RXUSRCLK1_IN,
    input           TILE2_RXUSRCLK20_IN,
    input           TILE2_RXUSRCLK21_IN,
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    input   [1:0]   TILE2_RXEQMIX0_IN,
    input   [1:0]   TILE2_RXEQMIX1_IN,
    input           TILE2_RXN0_IN,
    input           TILE2_RXN1_IN,
    input           TILE2_RXP0_IN,
    input           TILE2_RXP1_IN,
    //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    input           TILE2_RXENPMAPHASEALIGN0_IN,
    input           TILE2_RXENPMAPHASEALIGN1_IN,
    input           TILE2_RXPMASETPHASE0_IN,
    input           TILE2_RXPMASETPHASE1_IN,
    //-------------------------- TX/RX Datapath Ports --------------------------
    output  [1:0]   TILE2_GTPCLKFBEAST_OUT,
    output  [1:0]   TILE2_GTPCLKFBWEST_OUT,
    output  [1:0]   TILE2_GTPCLKOUT0_OUT,
    output  [1:0]   TILE2_GTPCLKOUT1_OUT,
    //----------------- Transmit Ports - 8b10b Encoder Control -----------------
    input   [1:0]   TILE2_TXCHARISK0_IN,
    input   [1:0]   TILE2_TXCHARISK1_IN,
    //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    input           TILE2_TXENPMAPHASEALIGN0_IN,
    input           TILE2_TXENPMAPHASEALIGN1_IN,
    input           TILE2_TXPMASETPHASE0_IN,
    input           TILE2_TXPMASETPHASE1_IN,
    //---------------- Transmit Ports - TX Data Path interface -----------------
    input   [15:0]  TILE2_TXDATA0_IN,
    input   [15:0]  TILE2_TXDATA1_IN,
    output          TILE2_TXOUTCLK0_OUT,
    output          TILE2_TXOUTCLK1_OUT,
    input           TILE2_TXUSRCLK0_IN,
    input           TILE2_TXUSRCLK1_IN,
    input           TILE2_TXUSRCLK20_IN,
    input           TILE2_TXUSRCLK21_IN,
    //------------- Transmit Ports - TX Driver and OOB signalling --------------
    output          TILE2_TXN0_OUT,
    output          TILE2_TXN1_OUT,
    output          TILE2_TXP0_OUT,
    output          TILE2_TXP1_OUT,
    //------------------- Transmit Ports - TX PRBS Generator -------------------
    input   [2:0]   TILE2_TXENPRBSTST0_IN,
    input   [2:0]   TILE2_TXENPRBSTST1_IN,


    
    //_________________________________________________________________________
    //_________________________________________________________________________
    //TILE3  (X1_Y1)

 
    //---------------------- Loopback and Powerdown Ports ----------------------
    input   [2:0]   TILE3_LOOPBACK0_IN,
    input   [2:0]   TILE3_LOOPBACK1_IN,
    //------------------------------- PLL Ports --------------------------------
    input           TILE3_CLK00_IN,
    input           TILE3_CLK01_IN,
    input           TILE3_GTPRESET0_IN,
    input           TILE3_GTPRESET1_IN,
    output          TILE3_PLLLKDET0_OUT,
    output          TILE3_RESETDONE0_OUT,
    output          TILE3_RESETDONE1_OUT,
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    output  [1:0]   TILE3_RXDISPERR0_OUT,
    output  [1:0]   TILE3_RXDISPERR1_OUT,
    output  [1:0]   TILE3_RXNOTINTABLE0_OUT,
    output  [1:0]   TILE3_RXNOTINTABLE1_OUT,
    //--------------------- Receive Ports - PRBS Detection ---------------------
    input           TILE3_PRBSCNTRESET0_IN,
    input           TILE3_PRBSCNTRESET1_IN,
    input   [2:0]   TILE3_RXENPRBSTST0_IN,
    input   [2:0]   TILE3_RXENPRBSTST1_IN,
    output          TILE3_RXPRBSERR0_OUT,
    output          TILE3_RXPRBSERR1_OUT,
    //----------------- Receive Ports - RX Data Path interface -----------------
    output  [15:0]  TILE3_RXDATA0_OUT,
    output  [15:0]  TILE3_RXDATA1_OUT,
    output          TILE3_RXRECCLK0_OUT,
    output          TILE3_RXRECCLK1_OUT,
    input           TILE3_RXUSRCLK0_IN,
    input           TILE3_RXUSRCLK1_IN,
    input           TILE3_RXUSRCLK20_IN,
    input           TILE3_RXUSRCLK21_IN,
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    input   [1:0]   TILE3_RXEQMIX0_IN,
    input   [1:0]   TILE3_RXEQMIX1_IN,
    input           TILE3_RXN0_IN,
    input           TILE3_RXN1_IN,
    input           TILE3_RXP0_IN,
    input           TILE3_RXP1_IN,
    //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    input           TILE3_RXENPMAPHASEALIGN0_IN,
    input           TILE3_RXENPMAPHASEALIGN1_IN,
    input           TILE3_RXPMASETPHASE0_IN,
    input           TILE3_RXPMASETPHASE1_IN,
    //-------------------------- TX/RX Datapath Ports --------------------------
    output  [1:0]   TILE3_GTPCLKFBEAST_OUT,
    output  [1:0]   TILE3_GTPCLKFBWEST_OUT,
    output  [1:0]   TILE3_GTPCLKOUT0_OUT,
    output  [1:0]   TILE3_GTPCLKOUT1_OUT,
    //----------------- Transmit Ports - 8b10b Encoder Control -----------------
    input   [1:0]   TILE3_TXCHARISK0_IN,
    input   [1:0]   TILE3_TXCHARISK1_IN,
    //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    input           TILE3_TXENPMAPHASEALIGN0_IN,
    input           TILE3_TXENPMAPHASEALIGN1_IN,
    input           TILE3_TXPMASETPHASE0_IN,
    input           TILE3_TXPMASETPHASE1_IN,
    //---------------- Transmit Ports - TX Data Path interface -----------------
    input   [15:0]  TILE3_TXDATA0_IN,
    input   [15:0]  TILE3_TXDATA1_IN,
    output          TILE3_TXOUTCLK0_OUT,
    output          TILE3_TXOUTCLK1_OUT,
    input           TILE3_TXUSRCLK0_IN,
    input           TILE3_TXUSRCLK1_IN,
    input           TILE3_TXUSRCLK20_IN,
    input           TILE3_TXUSRCLK21_IN,
    //------------- Transmit Ports - TX Driver and OOB signalling --------------
    output          TILE3_TXN0_OUT,
    output          TILE3_TXN1_OUT,
    output          TILE3_TXP0_OUT,
    output          TILE3_TXP1_OUT,
    //------------------- Transmit Ports - TX PRBS Generator -------------------
    input   [2:0]   TILE3_TXENPRBSTST0_IN,
    input   [2:0]   TILE3_TXENPRBSTST1_IN


);


//***************************** Wire Declarations *****************************

    // ground and vcc signals
    wire            tied_to_ground_i;
    wire    [63:0]  tied_to_ground_vec_i;
    wire            tied_to_vcc_i;
    wire    [63:0]  tied_to_vcc_vec_i;
    wire            tile0_plllkdet0_i;
    wire            tile0_plllkdet1_i;
    wire            tile1_plllkdet0_i;
    wire            tile1_plllkdet1_i;
    wire            tile2_plllkdet0_i;
    wire            tile2_plllkdet1_i;
    wire            tile3_plllkdet0_i;
    wire            tile3_plllkdet1_i;

    reg            tile0_plllkdet0_i2;
    reg    [4:0]   count00;
    reg            start00;
    reg            tile1_plllkdet0_i2;
    reg    [4:0]   count01;
    reg            start01;
    reg            tile2_plllkdet0_i2;
    reg    [4:0]   count02;
    reg            start02;
    reg            tile3_plllkdet0_i2;
    reg    [4:0]   count03;
    reg            start03;
 
    
//********************************* Main Body of Code**************************

    assign tied_to_ground_i             = 1'b0;
    assign tied_to_ground_vec_i         = 64'h0000000000000000;
    assign tied_to_vcc_i                = 1'b1;
    assign tied_to_vcc_vec_i            = 64'hffffffffffffffff;

generate
if (WRAPPER_SIMULATION==1) 
begin : simulation

    assign TILE0_PLLLKDET0_OUT = tile0_plllkdet0_i2;

    always@(posedge TILE0_CLK00_IN or posedge TILE0_GTPRESET0_IN)   
    begin    
      if (TILE0_GTPRESET0_IN == 1'b1) begin
        count00 <= 5'b00000;
      end
      else begin
        if ((count00 == 5'b10100) | (tile0_plllkdet0_i == 1'b0)) begin
          count00 <= 5'b00000;
        end
        else begin
          count00 <= count00 + 5'b00001;
        end
      end
    end

    always@(posedge TILE0_CLK00_IN or negedge tile0_plllkdet0_i)
    begin
      if(tile0_plllkdet0_i == 1'b0) begin
        tile0_plllkdet0_i2 <= 1'b0;
      end
      else begin
        if((count00 == 5'b10100) & (tile0_plllkdet0_i == 1'b1)) begin 
          tile0_plllkdet0_i2 <= 1'b1;
        end
      end
    end
    assign TILE1_PLLLKDET0_OUT = tile1_plllkdet0_i2;

    always@(posedge TILE1_CLK00_IN or posedge TILE1_GTPRESET0_IN)   
    begin    
      if (TILE1_GTPRESET0_IN == 1'b1) begin
        count01 <= 5'b00000;
      end
      else begin
        if ((count01 == 5'b10100) | (tile1_plllkdet0_i == 1'b0)) begin
          count01 <= 5'b00000;
        end
        else begin
          count01 <= count01 + 5'b00001;
        end
      end
    end

    always@(posedge TILE1_CLK00_IN or negedge tile1_plllkdet0_i)
    begin
      if(tile1_plllkdet0_i == 1'b0) begin
        tile1_plllkdet0_i2 <= 1'b0;
      end
      else begin
        if((count01 == 5'b10100) & (tile1_plllkdet0_i == 1'b1)) begin 
          tile1_plllkdet0_i2 <= 1'b1;
        end
      end
    end
    assign TILE2_PLLLKDET0_OUT = tile2_plllkdet0_i2;

    always@(posedge TILE2_CLK00_IN or posedge TILE2_GTPRESET0_IN)   
    begin    
      if (TILE2_GTPRESET0_IN == 1'b1) begin
        count02 <= 5'b00000;
      end
      else begin
        if ((count02 == 5'b10100) | (tile2_plllkdet0_i == 1'b0)) begin
          count02 <= 5'b00000;
        end
        else begin
          count02 <= count02 + 5'b00001;
        end
      end
    end

    always@(posedge TILE2_CLK00_IN or negedge tile2_plllkdet0_i)
    begin
      if(tile2_plllkdet0_i == 1'b0) begin
        tile2_plllkdet0_i2 <= 1'b0;
      end
      else begin
        if((count02 == 5'b10100) & (tile2_plllkdet0_i == 1'b1)) begin 
          tile2_plllkdet0_i2 <= 1'b1;
        end
      end
    end
    assign TILE3_PLLLKDET0_OUT = tile3_plllkdet0_i2;

    always@(posedge TILE3_CLK00_IN or posedge TILE3_GTPRESET0_IN)   
    begin    
      if (TILE3_GTPRESET0_IN == 1'b1) begin
        count03 <= 5'b00000;
      end
      else begin
        if ((count03 == 5'b10100) | (tile3_plllkdet0_i == 1'b0)) begin
          count03 <= 5'b00000;
        end
        else begin
          count03 <= count03 + 5'b00001;
        end
      end
    end

    always@(posedge TILE3_CLK00_IN or negedge tile3_plllkdet0_i)
    begin
      if(tile3_plllkdet0_i == 1'b0) begin
        tile3_plllkdet0_i2 <= 1'b0;
      end
      else begin
        if((count03 == 5'b10100) & (tile3_plllkdet0_i == 1'b1)) begin 
          tile3_plllkdet0_i2 <= 1'b1;
        end
      end
    end
    


end //end WRAPPER_SIMULATION =1 generate section
else
begin: implementation

    assign TILE0_PLLLKDET0_OUT = tile0_plllkdet0_i;
    assign TILE1_PLLLKDET0_OUT = tile1_plllkdet0_i;
    assign TILE2_PLLLKDET0_OUT = tile2_plllkdet0_i;
    assign TILE3_PLLLKDET0_OUT = tile3_plllkdet0_i;
    

end
endgenerate //End generate for WRAPPER_SIMULATION

    //------------------------- Tile Instances  -------------------------------   



    //_________________________________________________________________________
    //_________________________________________________________________________
    //TILE0  (X0_Y0)

    SER16_TILE #
    (
        // Simulation attributes
        .TILE_SIM_GTPRESET_SPEEDUP   (WRAPPER_SIM_GTPRESET_SPEEDUP),
        .TILE_CLK25_DIVIDER_0        (WRAPPER_CLK25_DIVIDER_0),
        .TILE_CLK25_DIVIDER_1        (WRAPPER_CLK25_DIVIDER_1),
        .TILE_PLL_DIVSEL_FB_0        (WRAPPER_PLL_DIVSEL_FB_0),
        .TILE_PLL_DIVSEL_FB_1        (WRAPPER_PLL_DIVSEL_FB_1),
        .TILE_PLL_DIVSEL_REF_0       (WRAPPER_PLL_DIVSEL_REF_0),
        .TILE_PLL_DIVSEL_REF_1       (WRAPPER_PLL_DIVSEL_REF_1),
  
        
        //
        .TILE_PLL_SOURCE_0               ("PLL0"),
        .TILE_PLL_SOURCE_1               ("PLL0")
    )
    tile0_ser16_i
    (
        //---------------------- Loopback and Powerdown Ports ----------------------
        .LOOPBACK0_IN                   (TILE0_LOOPBACK0_IN),
        .LOOPBACK1_IN                   (TILE0_LOOPBACK1_IN),
        //------------------------------- PLL Ports --------------------------------
        .CLK00_IN                       (TILE0_CLK00_IN),
        .CLK01_IN                       (TILE0_CLK01_IN),
        .GTPRESET0_IN                   (TILE0_GTPRESET0_IN),
        .GTPRESET1_IN                   (TILE0_GTPRESET1_IN),
        .PLLLKDET0_OUT                  (tile0_plllkdet0_i),
        .PLLLKDET1_OUT                  (tile0_plllkdet1_i),
        .RESETDONE0_OUT                 (TILE0_RESETDONE0_OUT),
        .RESETDONE1_OUT                 (TILE0_RESETDONE1_OUT),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .RXDISPERR0_OUT                 (TILE0_RXDISPERR0_OUT),
        .RXDISPERR1_OUT                 (TILE0_RXDISPERR1_OUT),
        .RXNOTINTABLE0_OUT              (TILE0_RXNOTINTABLE0_OUT),
        .RXNOTINTABLE1_OUT              (TILE0_RXNOTINTABLE1_OUT),
        //--------------------- Receive Ports - PRBS Detection ---------------------
        .PRBSCNTRESET0_IN               (TILE0_PRBSCNTRESET0_IN),
        .PRBSCNTRESET1_IN               (TILE0_PRBSCNTRESET1_IN),
        .RXENPRBSTST0_IN                (TILE0_RXENPRBSTST0_IN),
        .RXENPRBSTST1_IN                (TILE0_RXENPRBSTST1_IN),
        .RXPRBSERR0_OUT                 (TILE0_RXPRBSERR0_OUT),
        .RXPRBSERR1_OUT                 (TILE0_RXPRBSERR1_OUT),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .RXDATA0_OUT                    (TILE0_RXDATA0_OUT),
        .RXDATA1_OUT                    (TILE0_RXDATA1_OUT),
        .RXRECCLK0_OUT                  (TILE0_RXRECCLK0_OUT),
        .RXRECCLK1_OUT                  (TILE0_RXRECCLK1_OUT),
        .RXUSRCLK0_IN                   (TILE0_RXUSRCLK0_IN),
        .RXUSRCLK1_IN                   (TILE0_RXUSRCLK1_IN),
        .RXUSRCLK20_IN                  (TILE0_RXUSRCLK20_IN),
        .RXUSRCLK21_IN                  (TILE0_RXUSRCLK21_IN),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .RXEQMIX0_IN                    (TILE0_RXEQMIX0_IN),
        .RXEQMIX1_IN                    (TILE0_RXEQMIX1_IN),
        .RXN0_IN                        (TILE0_RXN0_IN),
        .RXN1_IN                        (TILE0_RXN1_IN),
        .RXP0_IN                        (TILE0_RXP0_IN),
        .RXP1_IN                        (TILE0_RXP1_IN),
        //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        .RXENPMAPHASEALIGN0_IN          (TILE0_RXENPMAPHASEALIGN0_IN),
        .RXENPMAPHASEALIGN1_IN          (TILE0_RXENPMAPHASEALIGN1_IN),
        .RXPMASETPHASE0_IN              (TILE0_RXPMASETPHASE0_IN),
        .RXPMASETPHASE1_IN              (TILE0_RXPMASETPHASE1_IN),
        //-------------------------- TX/RX Datapath Ports --------------------------
        .GTPCLKFBEAST_OUT               (TILE0_GTPCLKFBEAST_OUT),
        .GTPCLKFBWEST_OUT               (TILE0_GTPCLKFBWEST_OUT),
        .GTPCLKOUT0_OUT                 (TILE0_GTPCLKOUT0_OUT),
        .GTPCLKOUT1_OUT                 (TILE0_GTPCLKOUT1_OUT),
        //----------------- Transmit Ports - 8b10b Encoder Control -----------------
        .TXCHARISK0_IN                  (TILE0_TXCHARISK0_IN),
        .TXCHARISK1_IN                  (TILE0_TXCHARISK1_IN),
        //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        .TXENPMAPHASEALIGN0_IN          (TILE0_TXENPMAPHASEALIGN0_IN),
        .TXENPMAPHASEALIGN1_IN          (TILE0_TXENPMAPHASEALIGN1_IN),
        .TXPMASETPHASE0_IN              (TILE0_TXPMASETPHASE0_IN),
        .TXPMASETPHASE1_IN              (TILE0_TXPMASETPHASE1_IN),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .TXDATA0_IN                     (TILE0_TXDATA0_IN),
        .TXDATA1_IN                     (TILE0_TXDATA1_IN),
        .TXOUTCLK0_OUT                  (TILE0_TXOUTCLK0_OUT),
        .TXOUTCLK1_OUT                  (TILE0_TXOUTCLK1_OUT),
        .TXUSRCLK0_IN                   (TILE0_TXUSRCLK0_IN),
        .TXUSRCLK1_IN                   (TILE0_TXUSRCLK1_IN),
        .TXUSRCLK20_IN                  (TILE0_TXUSRCLK20_IN),
        .TXUSRCLK21_IN                  (TILE0_TXUSRCLK21_IN),
        //------------- Transmit Ports - TX Driver and OOB signalling --------------
        .TXN0_OUT                       (TILE0_TXN0_OUT),
        .TXN1_OUT                       (TILE0_TXN1_OUT),
        .TXP0_OUT                       (TILE0_TXP0_OUT),
        .TXP1_OUT                       (TILE0_TXP1_OUT),
        //------------------- Transmit Ports - TX PRBS Generator -------------------
        .TXENPRBSTST0_IN                (TILE0_TXENPRBSTST0_IN),
        .TXENPRBSTST1_IN                (TILE0_TXENPRBSTST1_IN)

    );



    //_________________________________________________________________________
    //_________________________________________________________________________
    //TILE1  (X1_Y0)

    SER16_TILE #
    (
        // Simulation attributes
        .TILE_SIM_GTPRESET_SPEEDUP   (WRAPPER_SIM_GTPRESET_SPEEDUP),
        .TILE_CLK25_DIVIDER_0        (WRAPPER_CLK25_DIVIDER_0),
        .TILE_CLK25_DIVIDER_1        (WRAPPER_CLK25_DIVIDER_1),
        .TILE_PLL_DIVSEL_FB_0        (WRAPPER_PLL_DIVSEL_FB_0),
        .TILE_PLL_DIVSEL_FB_1        (WRAPPER_PLL_DIVSEL_FB_1),
        .TILE_PLL_DIVSEL_REF_0       (WRAPPER_PLL_DIVSEL_REF_0),
        .TILE_PLL_DIVSEL_REF_1       (WRAPPER_PLL_DIVSEL_REF_1),
  
        
        //
        .TILE_PLL_SOURCE_0               ("PLL0"),
        .TILE_PLL_SOURCE_1               ("PLL0")
    )
    tile1_ser16_i
    (
        //---------------------- Loopback and Powerdown Ports ----------------------
        .LOOPBACK0_IN                   (TILE1_LOOPBACK0_IN),
        .LOOPBACK1_IN                   (TILE1_LOOPBACK1_IN),
        //------------------------------- PLL Ports --------------------------------
        .CLK00_IN                       (TILE1_CLK00_IN),
        .CLK01_IN                       (TILE1_CLK01_IN),
        .GTPRESET0_IN                   (TILE1_GTPRESET0_IN),
        .GTPRESET1_IN                   (TILE1_GTPRESET1_IN),
        .PLLLKDET0_OUT                  (tile1_plllkdet0_i),
        .PLLLKDET1_OUT                  (tile1_plllkdet1_i),
        .RESETDONE0_OUT                 (TILE1_RESETDONE0_OUT),
        .RESETDONE1_OUT                 (TILE1_RESETDONE1_OUT),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .RXDISPERR0_OUT                 (TILE1_RXDISPERR0_OUT),
        .RXDISPERR1_OUT                 (TILE1_RXDISPERR1_OUT),
        .RXNOTINTABLE0_OUT              (TILE1_RXNOTINTABLE0_OUT),
        .RXNOTINTABLE1_OUT              (TILE1_RXNOTINTABLE1_OUT),
        //--------------------- Receive Ports - PRBS Detection ---------------------
        .PRBSCNTRESET0_IN               (TILE1_PRBSCNTRESET0_IN),
        .PRBSCNTRESET1_IN               (TILE1_PRBSCNTRESET1_IN),
        .RXENPRBSTST0_IN                (TILE1_RXENPRBSTST0_IN),
        .RXENPRBSTST1_IN                (TILE1_RXENPRBSTST1_IN),
        .RXPRBSERR0_OUT                 (TILE1_RXPRBSERR0_OUT),
        .RXPRBSERR1_OUT                 (TILE1_RXPRBSERR1_OUT),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .RXDATA0_OUT                    (TILE1_RXDATA0_OUT),
        .RXDATA1_OUT                    (TILE1_RXDATA1_OUT),
        .RXRECCLK0_OUT                  (TILE1_RXRECCLK0_OUT),
        .RXRECCLK1_OUT                  (TILE1_RXRECCLK1_OUT),
        .RXUSRCLK0_IN                   (TILE1_RXUSRCLK0_IN),
        .RXUSRCLK1_IN                   (TILE1_RXUSRCLK1_IN),
        .RXUSRCLK20_IN                  (TILE1_RXUSRCLK20_IN),
        .RXUSRCLK21_IN                  (TILE1_RXUSRCLK21_IN),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .RXEQMIX0_IN                    (TILE1_RXEQMIX0_IN),
        .RXEQMIX1_IN                    (TILE1_RXEQMIX1_IN),
        .RXN0_IN                        (TILE1_RXN0_IN),
        .RXN1_IN                        (TILE1_RXN1_IN),
        .RXP0_IN                        (TILE1_RXP0_IN),
        .RXP1_IN                        (TILE1_RXP1_IN),
        //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        .RXENPMAPHASEALIGN0_IN          (TILE1_RXENPMAPHASEALIGN0_IN),
        .RXENPMAPHASEALIGN1_IN          (TILE1_RXENPMAPHASEALIGN1_IN),
        .RXPMASETPHASE0_IN              (TILE1_RXPMASETPHASE0_IN),
        .RXPMASETPHASE1_IN              (TILE1_RXPMASETPHASE1_IN),
        //-------------------------- TX/RX Datapath Ports --------------------------
        .GTPCLKFBEAST_OUT               (TILE1_GTPCLKFBEAST_OUT),
        .GTPCLKFBWEST_OUT               (TILE1_GTPCLKFBWEST_OUT),
        .GTPCLKOUT0_OUT                 (TILE1_GTPCLKOUT0_OUT),
        .GTPCLKOUT1_OUT                 (TILE1_GTPCLKOUT1_OUT),
        //----------------- Transmit Ports - 8b10b Encoder Control -----------------
        .TXCHARISK0_IN                  (TILE1_TXCHARISK0_IN),
        .TXCHARISK1_IN                  (TILE1_TXCHARISK1_IN),
        //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        .TXENPMAPHASEALIGN0_IN          (TILE1_TXENPMAPHASEALIGN0_IN),
        .TXENPMAPHASEALIGN1_IN          (TILE1_TXENPMAPHASEALIGN1_IN),
        .TXPMASETPHASE0_IN              (TILE1_TXPMASETPHASE0_IN),
        .TXPMASETPHASE1_IN              (TILE1_TXPMASETPHASE1_IN),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .TXDATA0_IN                     (TILE1_TXDATA0_IN),
        .TXDATA1_IN                     (TILE1_TXDATA1_IN),
        .TXOUTCLK0_OUT                  (TILE1_TXOUTCLK0_OUT),
        .TXOUTCLK1_OUT                  (TILE1_TXOUTCLK1_OUT),
        .TXUSRCLK0_IN                   (TILE1_TXUSRCLK0_IN),
        .TXUSRCLK1_IN                   (TILE1_TXUSRCLK1_IN),
        .TXUSRCLK20_IN                  (TILE1_TXUSRCLK20_IN),
        .TXUSRCLK21_IN                  (TILE1_TXUSRCLK21_IN),
        //------------- Transmit Ports - TX Driver and OOB signalling --------------
        .TXN0_OUT                       (TILE1_TXN0_OUT),
        .TXN1_OUT                       (TILE1_TXN1_OUT),
        .TXP0_OUT                       (TILE1_TXP0_OUT),
        .TXP1_OUT                       (TILE1_TXP1_OUT),
        //------------------- Transmit Ports - TX PRBS Generator -------------------
        .TXENPRBSTST0_IN                (TILE1_TXENPRBSTST0_IN),
        .TXENPRBSTST1_IN                (TILE1_TXENPRBSTST1_IN)

    );



    //_________________________________________________________________________
    //_________________________________________________________________________
    //TILE2  (X0_Y1)

    SER16_TILE #
    (
        // Simulation attributes
        .TILE_SIM_GTPRESET_SPEEDUP   (WRAPPER_SIM_GTPRESET_SPEEDUP),
        .TILE_CLK25_DIVIDER_0        (WRAPPER_CLK25_DIVIDER_0),
        .TILE_CLK25_DIVIDER_1        (WRAPPER_CLK25_DIVIDER_1),
        .TILE_PLL_DIVSEL_FB_0        (WRAPPER_PLL_DIVSEL_FB_0),
        .TILE_PLL_DIVSEL_FB_1        (WRAPPER_PLL_DIVSEL_FB_1),
        .TILE_PLL_DIVSEL_REF_0       (WRAPPER_PLL_DIVSEL_REF_0),
        .TILE_PLL_DIVSEL_REF_1       (WRAPPER_PLL_DIVSEL_REF_1),
  
        
        //
        .TILE_PLL_SOURCE_0               ("PLL0"),
        .TILE_PLL_SOURCE_1               ("PLL0")
    )
    tile2_ser16_i
    (
        //---------------------- Loopback and Powerdown Ports ----------------------
        .LOOPBACK0_IN                   (TILE2_LOOPBACK0_IN),
        .LOOPBACK1_IN                   (TILE2_LOOPBACK1_IN),
        //------------------------------- PLL Ports --------------------------------
        .CLK00_IN                       (TILE2_CLK00_IN),
        .CLK01_IN                       (TILE2_CLK01_IN),
        .GTPRESET0_IN                   (TILE2_GTPRESET0_IN),
        .GTPRESET1_IN                   (TILE2_GTPRESET1_IN),
        .PLLLKDET0_OUT                  (tile2_plllkdet0_i),
        .PLLLKDET1_OUT                  (tile2_plllkdet1_i),
        .RESETDONE0_OUT                 (TILE2_RESETDONE0_OUT),
        .RESETDONE1_OUT                 (TILE2_RESETDONE1_OUT),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .RXDISPERR0_OUT                 (TILE2_RXDISPERR0_OUT),
        .RXDISPERR1_OUT                 (TILE2_RXDISPERR1_OUT),
        .RXNOTINTABLE0_OUT              (TILE2_RXNOTINTABLE0_OUT),
        .RXNOTINTABLE1_OUT              (TILE2_RXNOTINTABLE1_OUT),
        //--------------------- Receive Ports - PRBS Detection ---------------------
        .PRBSCNTRESET0_IN               (TILE2_PRBSCNTRESET0_IN),
        .PRBSCNTRESET1_IN               (TILE2_PRBSCNTRESET1_IN),
        .RXENPRBSTST0_IN                (TILE2_RXENPRBSTST0_IN),
        .RXENPRBSTST1_IN                (TILE2_RXENPRBSTST1_IN),
        .RXPRBSERR0_OUT                 (TILE2_RXPRBSERR0_OUT),
        .RXPRBSERR1_OUT                 (TILE2_RXPRBSERR1_OUT),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .RXDATA0_OUT                    (TILE2_RXDATA0_OUT),
        .RXDATA1_OUT                    (TILE2_RXDATA1_OUT),
        .RXRECCLK0_OUT                  (TILE2_RXRECCLK0_OUT),
        .RXRECCLK1_OUT                  (TILE2_RXRECCLK1_OUT),
        .RXUSRCLK0_IN                   (TILE2_RXUSRCLK0_IN),
        .RXUSRCLK1_IN                   (TILE2_RXUSRCLK1_IN),
        .RXUSRCLK20_IN                  (TILE2_RXUSRCLK20_IN),
        .RXUSRCLK21_IN                  (TILE2_RXUSRCLK21_IN),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .RXEQMIX0_IN                    (TILE2_RXEQMIX0_IN),
        .RXEQMIX1_IN                    (TILE2_RXEQMIX1_IN),
        .RXN0_IN                        (TILE2_RXN0_IN),
        .RXN1_IN                        (TILE2_RXN1_IN),
        .RXP0_IN                        (TILE2_RXP0_IN),
        .RXP1_IN                        (TILE2_RXP1_IN),
        //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        .RXENPMAPHASEALIGN0_IN          (TILE2_RXENPMAPHASEALIGN0_IN),
        .RXENPMAPHASEALIGN1_IN          (TILE2_RXENPMAPHASEALIGN1_IN),
        .RXPMASETPHASE0_IN              (TILE2_RXPMASETPHASE0_IN),
        .RXPMASETPHASE1_IN              (TILE2_RXPMASETPHASE1_IN),
        //-------------------------- TX/RX Datapath Ports --------------------------
        .GTPCLKFBEAST_OUT               (TILE2_GTPCLKFBEAST_OUT),
        .GTPCLKFBWEST_OUT               (TILE2_GTPCLKFBWEST_OUT),
        .GTPCLKOUT0_OUT                 (TILE2_GTPCLKOUT0_OUT),
        .GTPCLKOUT1_OUT                 (TILE2_GTPCLKOUT1_OUT),
        //----------------- Transmit Ports - 8b10b Encoder Control -----------------
        .TXCHARISK0_IN                  (TILE2_TXCHARISK0_IN),
        .TXCHARISK1_IN                  (TILE2_TXCHARISK1_IN),
        //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        .TXENPMAPHASEALIGN0_IN          (TILE2_TXENPMAPHASEALIGN0_IN),
        .TXENPMAPHASEALIGN1_IN          (TILE2_TXENPMAPHASEALIGN1_IN),
        .TXPMASETPHASE0_IN              (TILE2_TXPMASETPHASE0_IN),
        .TXPMASETPHASE1_IN              (TILE2_TXPMASETPHASE1_IN),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .TXDATA0_IN                     (TILE2_TXDATA0_IN),
        .TXDATA1_IN                     (TILE2_TXDATA1_IN),
        .TXOUTCLK0_OUT                  (TILE2_TXOUTCLK0_OUT),
        .TXOUTCLK1_OUT                  (TILE2_TXOUTCLK1_OUT),
        .TXUSRCLK0_IN                   (TILE2_TXUSRCLK0_IN),
        .TXUSRCLK1_IN                   (TILE2_TXUSRCLK1_IN),
        .TXUSRCLK20_IN                  (TILE2_TXUSRCLK20_IN),
        .TXUSRCLK21_IN                  (TILE2_TXUSRCLK21_IN),
        //------------- Transmit Ports - TX Driver and OOB signalling --------------
        .TXN0_OUT                       (TILE2_TXN0_OUT),
        .TXN1_OUT                       (TILE2_TXN1_OUT),
        .TXP0_OUT                       (TILE2_TXP0_OUT),
        .TXP1_OUT                       (TILE2_TXP1_OUT),
        //------------------- Transmit Ports - TX PRBS Generator -------------------
        .TXENPRBSTST0_IN                (TILE2_TXENPRBSTST0_IN),
        .TXENPRBSTST1_IN                (TILE2_TXENPRBSTST1_IN)

    );



    //_________________________________________________________________________
    //_________________________________________________________________________
    //TILE3  (X1_Y1)

    SER16_TILE #
    (
        // Simulation attributes
        .TILE_SIM_GTPRESET_SPEEDUP   (WRAPPER_SIM_GTPRESET_SPEEDUP),
        .TILE_CLK25_DIVIDER_0        (WRAPPER_CLK25_DIVIDER_0),
        .TILE_CLK25_DIVIDER_1        (WRAPPER_CLK25_DIVIDER_1),
        .TILE_PLL_DIVSEL_FB_0        (WRAPPER_PLL_DIVSEL_FB_0),
        .TILE_PLL_DIVSEL_FB_1        (WRAPPER_PLL_DIVSEL_FB_1),
        .TILE_PLL_DIVSEL_REF_0       (WRAPPER_PLL_DIVSEL_REF_0),
        .TILE_PLL_DIVSEL_REF_1       (WRAPPER_PLL_DIVSEL_REF_1),
  
        
        //
        .TILE_PLL_SOURCE_0               ("PLL0"),
        .TILE_PLL_SOURCE_1               ("PLL0")
    )
    tile3_ser16_i
    (
        //---------------------- Loopback and Powerdown Ports ----------------------
        .LOOPBACK0_IN                   (TILE3_LOOPBACK0_IN),
        .LOOPBACK1_IN                   (TILE3_LOOPBACK1_IN),
        //------------------------------- PLL Ports --------------------------------
        .CLK00_IN                       (TILE3_CLK00_IN),
        .CLK01_IN                       (TILE3_CLK01_IN),
        .GTPRESET0_IN                   (TILE3_GTPRESET0_IN),
        .GTPRESET1_IN                   (TILE3_GTPRESET1_IN),
        .PLLLKDET0_OUT                  (tile3_plllkdet0_i),
        .PLLLKDET1_OUT                  (tile3_plllkdet1_i),
        .RESETDONE0_OUT                 (TILE3_RESETDONE0_OUT),
        .RESETDONE1_OUT                 (TILE3_RESETDONE1_OUT),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .RXDISPERR0_OUT                 (TILE3_RXDISPERR0_OUT),
        .RXDISPERR1_OUT                 (TILE3_RXDISPERR1_OUT),
        .RXNOTINTABLE0_OUT              (TILE3_RXNOTINTABLE0_OUT),
        .RXNOTINTABLE1_OUT              (TILE3_RXNOTINTABLE1_OUT),
        //--------------------- Receive Ports - PRBS Detection ---------------------
        .PRBSCNTRESET0_IN               (TILE3_PRBSCNTRESET0_IN),
        .PRBSCNTRESET1_IN               (TILE3_PRBSCNTRESET1_IN),
        .RXENPRBSTST0_IN                (TILE3_RXENPRBSTST0_IN),
        .RXENPRBSTST1_IN                (TILE3_RXENPRBSTST1_IN),
        .RXPRBSERR0_OUT                 (TILE3_RXPRBSERR0_OUT),
        .RXPRBSERR1_OUT                 (TILE3_RXPRBSERR1_OUT),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .RXDATA0_OUT                    (TILE3_RXDATA0_OUT),
        .RXDATA1_OUT                    (TILE3_RXDATA1_OUT),
        .RXRECCLK0_OUT                  (TILE3_RXRECCLK0_OUT),
        .RXRECCLK1_OUT                  (TILE3_RXRECCLK1_OUT),
        .RXUSRCLK0_IN                   (TILE3_RXUSRCLK0_IN),
        .RXUSRCLK1_IN                   (TILE3_RXUSRCLK1_IN),
        .RXUSRCLK20_IN                  (TILE3_RXUSRCLK20_IN),
        .RXUSRCLK21_IN                  (TILE3_RXUSRCLK21_IN),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .RXEQMIX0_IN                    (TILE3_RXEQMIX0_IN),
        .RXEQMIX1_IN                    (TILE3_RXEQMIX1_IN),
        .RXN0_IN                        (TILE3_RXN0_IN),
        .RXN1_IN                        (TILE3_RXN1_IN),
        .RXP0_IN                        (TILE3_RXP0_IN),
        .RXP1_IN                        (TILE3_RXP1_IN),
        //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        .RXENPMAPHASEALIGN0_IN          (TILE3_RXENPMAPHASEALIGN0_IN),
        .RXENPMAPHASEALIGN1_IN          (TILE3_RXENPMAPHASEALIGN1_IN),
        .RXPMASETPHASE0_IN              (TILE3_RXPMASETPHASE0_IN),
        .RXPMASETPHASE1_IN              (TILE3_RXPMASETPHASE1_IN),
        //-------------------------- TX/RX Datapath Ports --------------------------
        .GTPCLKFBEAST_OUT               (TILE3_GTPCLKFBEAST_OUT),
        .GTPCLKFBWEST_OUT               (TILE3_GTPCLKFBWEST_OUT),
        .GTPCLKOUT0_OUT                 (TILE3_GTPCLKOUT0_OUT),
        .GTPCLKOUT1_OUT                 (TILE3_GTPCLKOUT1_OUT),
        //----------------- Transmit Ports - 8b10b Encoder Control -----------------
        .TXCHARISK0_IN                  (TILE3_TXCHARISK0_IN),
        .TXCHARISK1_IN                  (TILE3_TXCHARISK1_IN),
        //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        .TXENPMAPHASEALIGN0_IN          (TILE3_TXENPMAPHASEALIGN0_IN),
        .TXENPMAPHASEALIGN1_IN          (TILE3_TXENPMAPHASEALIGN1_IN),
        .TXPMASETPHASE0_IN              (TILE3_TXPMASETPHASE0_IN),
        .TXPMASETPHASE1_IN              (TILE3_TXPMASETPHASE1_IN),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .TXDATA0_IN                     (TILE3_TXDATA0_IN),
        .TXDATA1_IN                     (TILE3_TXDATA1_IN),
        .TXOUTCLK0_OUT                  (TILE3_TXOUTCLK0_OUT),
        .TXOUTCLK1_OUT                  (TILE3_TXOUTCLK1_OUT),
        .TXUSRCLK0_IN                   (TILE3_TXUSRCLK0_IN),
        .TXUSRCLK1_IN                   (TILE3_TXUSRCLK1_IN),
        .TXUSRCLK20_IN                  (TILE3_TXUSRCLK20_IN),
        .TXUSRCLK21_IN                  (TILE3_TXUSRCLK21_IN),
        //------------- Transmit Ports - TX Driver and OOB signalling --------------
        .TXN0_OUT                       (TILE3_TXN0_OUT),
        .TXN1_OUT                       (TILE3_TXN1_OUT),
        .TXP0_OUT                       (TILE3_TXP0_OUT),
        .TXP1_OUT                       (TILE3_TXP1_OUT),
        //------------------- Transmit Ports - TX PRBS Generator -------------------
        .TXENPRBSTST0_IN                (TILE3_TXENPRBSTST0_IN),
        .TXENPRBSTST1_IN                (TILE3_TXENPRBSTST1_IN)

    );

    
     
endmodule

