-------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 1.11
--  \   \         Application : Spartan-6 FPGA GTP Transceiver Wizard
--  /   /         Filename : ser40a.vhd
-- /___/   /\      
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Module ser40a (a GTP Wrapper)
-- Generated by Xilinx Spartan-6 FPGA GTP Transceiver Wizard
-- 
-- 
-- (c) Copyright 2009 - 2011 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;


--***************************** Entity Declaration ****************************

entity ser40a is
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTPRESET_SPEEDUP    : integer   := 0; -- Set to 1 to speed up sim reset
    WRAPPER_CLK25_DIVIDER_0         : integer   := 10;
    WRAPPER_CLK25_DIVIDER_1         : integer   := 10;
    WRAPPER_PLL_DIVSEL_FB_0         : integer   := 2;
    WRAPPER_PLL_DIVSEL_FB_1         : integer   := 2;
    WRAPPER_PLL_DIVSEL_REF_0        : integer   := 1;
    WRAPPER_PLL_DIVSEL_REF_1        : integer   := 1;
    WRAPPER_SIMULATION              : integer   := 0  -- Set to 1 for simulation    
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE0  (X0_Y0)

 
    --------------------------------- PLL Ports --------------------------------
    TILE0_CLK00_IN                          : in   std_logic;
    TILE0_CLK01_IN                          : in   std_logic;
    TILE0_GTPRESET0_IN                      : in   std_logic;
    TILE0_GTPRESET1_IN                      : in   std_logic;
    TILE0_PLLLKDET0_OUT                     : out  std_logic;
    TILE0_RESETDONE0_OUT                    : out  std_logic;
    TILE0_RESETDONE1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE0_RXUSRCLK0_IN                      : in   std_logic;
    TILE0_RXUSRCLK1_IN                      : in   std_logic;
    TILE0_RXUSRCLK20_IN                     : in   std_logic;
    TILE0_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE0_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE0_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE0_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE0_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE0_TXDATA0_IN                        : in   std_logic_vector(39 downto 0);
    TILE0_TXDATA1_IN                        : in   std_logic_vector(39 downto 0);
    TILE0_TXOUTCLK0_OUT                     : out  std_logic;
    TILE0_TXOUTCLK1_OUT                     : out  std_logic;
    TILE0_TXUSRCLK0_IN                      : in   std_logic;
    TILE0_TXUSRCLK1_IN                      : in   std_logic;
    TILE0_TXUSRCLK20_IN                     : in   std_logic;
    TILE0_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE0_TXN0_OUT                          : out  std_logic;
    TILE0_TXN1_OUT                          : out  std_logic;
    TILE0_TXP0_OUT                          : out  std_logic;
    TILE0_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE0_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE0_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE0_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE0_TXPRBSFORCEERR1_IN                : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE1  (X1_Y0)

 
    --------------------------------- PLL Ports --------------------------------
    TILE1_CLK00_IN                          : in   std_logic;
    TILE1_CLK01_IN                          : in   std_logic;
    TILE1_GTPRESET0_IN                      : in   std_logic;
    TILE1_GTPRESET1_IN                      : in   std_logic;
    TILE1_PLLLKDET0_OUT                     : out  std_logic;
    TILE1_RESETDONE0_OUT                    : out  std_logic;
    TILE1_RESETDONE1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE1_RXUSRCLK0_IN                      : in   std_logic;
    TILE1_RXUSRCLK1_IN                      : in   std_logic;
    TILE1_RXUSRCLK20_IN                     : in   std_logic;
    TILE1_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE1_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE1_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE1_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE1_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE1_TXDATA0_IN                        : in   std_logic_vector(39 downto 0);
    TILE1_TXDATA1_IN                        : in   std_logic_vector(39 downto 0);
    TILE1_TXOUTCLK0_OUT                     : out  std_logic;
    TILE1_TXOUTCLK1_OUT                     : out  std_logic;
    TILE1_TXUSRCLK0_IN                      : in   std_logic;
    TILE1_TXUSRCLK1_IN                      : in   std_logic;
    TILE1_TXUSRCLK20_IN                     : in   std_logic;
    TILE1_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE1_TXN0_OUT                          : out  std_logic;
    TILE1_TXN1_OUT                          : out  std_logic;
    TILE1_TXP0_OUT                          : out  std_logic;
    TILE1_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE1_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE1_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE1_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE1_TXPRBSFORCEERR1_IN                : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE2  (X0_Y1)

 
    --------------------------------- PLL Ports --------------------------------
    TILE2_CLK00_IN                          : in   std_logic;
    TILE2_CLK01_IN                          : in   std_logic;
    TILE2_GTPRESET0_IN                      : in   std_logic;
    TILE2_GTPRESET1_IN                      : in   std_logic;
    TILE2_PLLLKDET0_OUT                     : out  std_logic;
    TILE2_RESETDONE0_OUT                    : out  std_logic;
    TILE2_RESETDONE1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE2_RXUSRCLK0_IN                      : in   std_logic;
    TILE2_RXUSRCLK1_IN                      : in   std_logic;
    TILE2_RXUSRCLK20_IN                     : in   std_logic;
    TILE2_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE2_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE2_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE2_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE2_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE2_TXDATA0_IN                        : in   std_logic_vector(39 downto 0);
    TILE2_TXDATA1_IN                        : in   std_logic_vector(39 downto 0);
    TILE2_TXOUTCLK0_OUT                     : out  std_logic;
    TILE2_TXOUTCLK1_OUT                     : out  std_logic;
    TILE2_TXUSRCLK0_IN                      : in   std_logic;
    TILE2_TXUSRCLK1_IN                      : in   std_logic;
    TILE2_TXUSRCLK20_IN                     : in   std_logic;
    TILE2_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE2_TXN0_OUT                          : out  std_logic;
    TILE2_TXN1_OUT                          : out  std_logic;
    TILE2_TXP0_OUT                          : out  std_logic;
    TILE2_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE2_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE2_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE2_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE2_TXPRBSFORCEERR1_IN                : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE3  (X1_Y1)

 
    --------------------------------- PLL Ports --------------------------------
    TILE3_CLK00_IN                          : in   std_logic;
    TILE3_CLK01_IN                          : in   std_logic;
    TILE3_GTPRESET0_IN                      : in   std_logic;
    TILE3_GTPRESET1_IN                      : in   std_logic;
    TILE3_PLLLKDET0_OUT                     : out  std_logic;
    TILE3_RESETDONE0_OUT                    : out  std_logic;
    TILE3_RESETDONE1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE3_RXUSRCLK0_IN                      : in   std_logic;
    TILE3_RXUSRCLK1_IN                      : in   std_logic;
    TILE3_RXUSRCLK20_IN                     : in   std_logic;
    TILE3_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE3_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE3_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE3_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE3_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE3_TXDATA0_IN                        : in   std_logic_vector(39 downto 0);
    TILE3_TXDATA1_IN                        : in   std_logic_vector(39 downto 0);
    TILE3_TXOUTCLK0_OUT                     : out  std_logic;
    TILE3_TXOUTCLK1_OUT                     : out  std_logic;
    TILE3_TXUSRCLK0_IN                      : in   std_logic;
    TILE3_TXUSRCLK1_IN                      : in   std_logic;
    TILE3_TXUSRCLK20_IN                     : in   std_logic;
    TILE3_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE3_TXN0_OUT                          : out  std_logic;
    TILE3_TXN1_OUT                          : out  std_logic;
    TILE3_TXP0_OUT                          : out  std_logic;
    TILE3_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE3_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE3_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE3_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE3_TXPRBSFORCEERR1_IN                : in   std_logic


);


end ser40a;

architecture RTL of ser40a is
  attribute CORE_GENERATION_INFO           : string;
  attribute CORE_GENERATION_INFO of RTL    : architecture is "ser40a,s6_gtpwizard_v1_11,{gtp0_protocol_file=Start_from_scratch,gtp1_protocol_file=Use_GTP0_settings}";

--***************************** Signal Declarations *****************************

    -- ground and tied_to_vcc_i signals
    signal  tied_to_ground_i                :   std_logic;
    signal  tied_to_ground_vec_i            :   std_logic_vector(63 downto 0);
    signal  tied_to_vcc_i                   :   std_logic;
    
    signal  tile0_plllkdet0_i       :   std_logic;  
    signal  tile0_plllkdet1_i       :   std_logic;  
    signal  tile1_plllkdet0_i       :   std_logic;  
    signal  tile1_plllkdet1_i       :   std_logic;  
    signal  tile2_plllkdet0_i       :   std_logic;  
    signal  tile2_plllkdet1_i       :   std_logic;  
    signal  tile3_plllkdet0_i       :   std_logic;  
    signal  tile3_plllkdet1_i       :   std_logic;  

    signal  tile0_plllkdet0_i2       :   std_logic; 
    signal  count00                  :   std_logic_vector(4 downto 0);
    signal  tile1_plllkdet0_i2       :   std_logic; 
    signal  count01                  :   std_logic_vector(4 downto 0);
    signal  tile2_plllkdet0_i2       :   std_logic; 
    signal  count02                  :   std_logic_vector(4 downto 0);
    signal  tile3_plllkdet0_i2       :   std_logic; 
    signal  count03                  :   std_logic_vector(4 downto 0);
     

--*************************** Component Declarations **************************

component ser40a_tile 
generic
(
    -- Simulation attributes
    TILE_SIM_GTPRESET_SPEEDUP    : integer   := 0; -- Set to 1 to speed up sim reset 
    TILE_CLK25_DIVIDER_0         : integer   := 10; 
    TILE_CLK25_DIVIDER_1         : integer   := 10;
    TILE_PLL_DIVSEL_FB_0         : integer   := 2;
    TILE_PLL_DIVSEL_FB_1         : integer   := 2;
    TILE_PLL_DIVSEL_REF_0        : integer   := 1;
    TILE_PLL_DIVSEL_REF_1        : integer   := 1;
 
    --
    TILE_PLL_SOURCE_0            : string    := "PLL0";
    TILE_PLL_SOURCE_1            : string    := "PLL1"    
);
port 
(   
    --------------------------------- PLL Ports --------------------------------
    CLK00_IN                                : in   std_logic;
    CLK01_IN                                : in   std_logic;
    GTPRESET0_IN                            : in   std_logic;
    GTPRESET1_IN                            : in   std_logic;
    PLLLKDET0_OUT                           : out  std_logic;
    PLLLKDET1_OUT                           : out  std_logic;
    RESETDONE0_OUT                          : out  std_logic;
    RESETDONE1_OUT                          : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    RXUSRCLK0_IN                            : in   std_logic;
    RXUSRCLK1_IN                            : in   std_logic;
    RXUSRCLK20_IN                           : in   std_logic;
    RXUSRCLK21_IN                           : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    RXEQMIX0_IN                             : in   std_logic_vector(1 downto 0);
    RXEQMIX1_IN                             : in   std_logic_vector(1 downto 0);
    ---------------------------- TX/RX Datapath Ports --------------------------
    GTPCLKOUT0_OUT                          : out  std_logic_vector(1 downto 0);
    GTPCLKOUT1_OUT                          : out  std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TXDATA0_IN                              : in   std_logic_vector(39 downto 0);
    TXDATA1_IN                              : in   std_logic_vector(39 downto 0);
    TXOUTCLK0_OUT                           : out  std_logic;
    TXOUTCLK1_OUT                           : out  std_logic;
    TXUSRCLK0_IN                            : in   std_logic;
    TXUSRCLK1_IN                            : in   std_logic;
    TXUSRCLK20_IN                           : in   std_logic;
    TXUSRCLK21_IN                           : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TXN0_OUT                                : out  std_logic;
    TXN1_OUT                                : out  std_logic;
    TXP0_OUT                                : out  std_logic;
    TXP1_OUT                                : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TXENPRBSTST0_IN                         : in   std_logic_vector(2 downto 0);
    TXENPRBSTST1_IN                         : in   std_logic_vector(2 downto 0);
    TXPRBSFORCEERR0_IN                      : in   std_logic;
    TXPRBSFORCEERR1_IN                      : in   std_logic


);
end component;


--********************************* Main Body of Code**************************

begin                       

    tied_to_ground_i                    <= '0';
    tied_to_ground_vec_i(63 downto 0)   <= (others => '0');
    tied_to_vcc_i                       <= '1';

simulation : if WRAPPER_SIMULATION = 1 generate

    TILE0_PLLLKDET0_OUT                     <= tile0_plllkdet0_i2;

process(TILE0_CLK00_IN,TILE0_GTPRESET0_IN)
begin
  if (TILE0_GTPRESET0_IN = '1') then    
    count00 <= "00000";
  elsif(TILE0_CLK00_IN'event and TILE0_CLK00_IN ='1') then
    if((count00 = "10100") or (tile0_plllkdet0_i = '0')) then
      count00 <= "00000";
    else
      count00 <= count00 + "00001";      
    end if;     
  end if;
end process; 

process(TILE0_CLK00_IN,tile0_plllkdet0_i)
begin
  if(tile0_plllkdet0_i = '0') then
    tile0_plllkdet0_i2 <= '0';
  elsif(TILE0_CLK00_IN'event and TILE0_CLK00_IN ='1') then
    if((count00 = "10100") and (tile0_plllkdet0_i = '1')) then
      tile0_plllkdet0_i2 <= '1';
    end if;     
  end if;
end process; 

    TILE1_PLLLKDET0_OUT                     <= tile1_plllkdet0_i2;

process(TILE1_CLK00_IN,TILE1_GTPRESET0_IN)
begin
  if (TILE1_GTPRESET0_IN = '1') then    
    count01 <= "00000";
  elsif(TILE1_CLK00_IN'event and TILE1_CLK00_IN ='1') then
    if((count01 = "10100") or (tile1_plllkdet0_i = '0')) then
      count01 <= "00000";
    else
      count01 <= count01 + "00001";      
    end if;     
  end if;
end process; 

process(TILE1_CLK00_IN,tile1_plllkdet0_i)
begin
  if(tile1_plllkdet0_i = '0') then
    tile1_plllkdet0_i2 <= '0';
  elsif(TILE1_CLK00_IN'event and TILE1_CLK00_IN ='1') then
    if((count01 = "10100") and (tile1_plllkdet0_i = '1')) then
      tile1_plllkdet0_i2 <= '1';
    end if;     
  end if;
end process; 

    TILE2_PLLLKDET0_OUT                     <= tile2_plllkdet0_i2;

process(TILE2_CLK00_IN,TILE2_GTPRESET0_IN)
begin
  if (TILE2_GTPRESET0_IN = '1') then    
    count02 <= "00000";
  elsif(TILE2_CLK00_IN'event and TILE2_CLK00_IN ='1') then
    if((count02 = "10100") or (tile2_plllkdet0_i = '0')) then
      count02 <= "00000";
    else
      count02 <= count02 + "00001";      
    end if;     
  end if;
end process; 

process(TILE2_CLK00_IN,tile2_plllkdet0_i)
begin
  if(tile2_plllkdet0_i = '0') then
    tile2_plllkdet0_i2 <= '0';
  elsif(TILE2_CLK00_IN'event and TILE2_CLK00_IN ='1') then
    if((count02 = "10100") and (tile2_plllkdet0_i = '1')) then
      tile2_plllkdet0_i2 <= '1';
    end if;     
  end if;
end process; 

    TILE3_PLLLKDET0_OUT                     <= tile3_plllkdet0_i2;

process(TILE3_CLK00_IN,TILE3_GTPRESET0_IN)
begin
  if (TILE3_GTPRESET0_IN = '1') then    
    count03 <= "00000";
  elsif(TILE3_CLK00_IN'event and TILE3_CLK00_IN ='1') then
    if((count03 = "10100") or (tile3_plllkdet0_i = '0')) then
      count03 <= "00000";
    else
      count03 <= count03 + "00001";      
    end if;     
  end if;
end process; 

process(TILE3_CLK00_IN,tile3_plllkdet0_i)
begin
  if(tile3_plllkdet0_i = '0') then
    tile3_plllkdet0_i2 <= '0';
  elsif(TILE3_CLK00_IN'event and TILE3_CLK00_IN ='1') then
    if((count03 = "10100") and (tile3_plllkdet0_i = '1')) then
      tile3_plllkdet0_i2 <= '1';
    end if;     
  end if;
end process; 

  


end generate simulation;

implementation : if WRAPPER_SIMULATION = 0 generate

    TILE0_PLLLKDET0_OUT                     <= tile0_plllkdet0_i;
    TILE1_PLLLKDET0_OUT                     <= tile1_plllkdet0_i;
    TILE2_PLLLKDET0_OUT                     <= tile2_plllkdet0_i;
    TILE3_PLLLKDET0_OUT                     <= tile3_plllkdet0_i;

end generate implementation;

    --------------------------- Tile Instances  -------------------------------   


    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE0  (X0_Y0)

    tile0_ser40a_i : ser40a_tile
    generic map
    (
        -- Simulation attributes
        TILE_SIM_GTPRESET_SPEEDUP    => WRAPPER_SIM_GTPRESET_SPEEDUP,
        TILE_CLK25_DIVIDER_0         => WRAPPER_CLK25_DIVIDER_0,
        TILE_CLK25_DIVIDER_1         => WRAPPER_CLK25_DIVIDER_1,
        TILE_PLL_DIVSEL_FB_0         => WRAPPER_PLL_DIVSEL_FB_0,
        TILE_PLL_DIVSEL_FB_1         => WRAPPER_PLL_DIVSEL_FB_1,
        TILE_PLL_DIVSEL_REF_0        => WRAPPER_PLL_DIVSEL_REF_0,
        TILE_PLL_DIVSEL_REF_1        => WRAPPER_PLL_DIVSEL_REF_1,
        
        -- 
        TILE_PLL_SOURCE_0            => "PLL0",
        TILE_PLL_SOURCE_1            => "PLL0"
    )
    port map
    (
        --------------------------------- PLL Ports --------------------------------
        CLK00_IN                        =>      TILE0_CLK00_IN,
        CLK01_IN                        =>      TILE0_CLK01_IN,
        GTPRESET0_IN                    =>      TILE0_GTPRESET0_IN,
        GTPRESET1_IN                    =>      TILE0_GTPRESET1_IN,
        PLLLKDET0_OUT                   =>      tile0_plllkdet0_i,
        PLLLKDET1_OUT                   =>      tile0_plllkdet1_i,
        RESETDONE0_OUT                  =>      TILE0_RESETDONE0_OUT,
        RESETDONE1_OUT                  =>      TILE0_RESETDONE1_OUT,
        ------------------- Receive Ports - RX Data Path interface -----------------
        RXUSRCLK0_IN                    =>      TILE0_RXUSRCLK0_IN,
        RXUSRCLK1_IN                    =>      TILE0_RXUSRCLK1_IN,
        RXUSRCLK20_IN                   =>      TILE0_RXUSRCLK20_IN,
        RXUSRCLK21_IN                   =>      TILE0_RXUSRCLK21_IN,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        RXEQMIX0_IN                     =>      TILE0_RXEQMIX0_IN,
        RXEQMIX1_IN                     =>      TILE0_RXEQMIX1_IN,
        ---------------------------- TX/RX Datapath Ports --------------------------
        GTPCLKOUT0_OUT                  =>      TILE0_GTPCLKOUT0_OUT,
        GTPCLKOUT1_OUT                  =>      TILE0_GTPCLKOUT1_OUT,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TXDATA0_IN                      =>      TILE0_TXDATA0_IN,
        TXDATA1_IN                      =>      TILE0_TXDATA1_IN,
        TXOUTCLK0_OUT                   =>      TILE0_TXOUTCLK0_OUT,
        TXOUTCLK1_OUT                   =>      TILE0_TXOUTCLK1_OUT,
        TXUSRCLK0_IN                    =>      TILE0_TXUSRCLK0_IN,
        TXUSRCLK1_IN                    =>      TILE0_TXUSRCLK1_IN,
        TXUSRCLK20_IN                   =>      TILE0_TXUSRCLK20_IN,
        TXUSRCLK21_IN                   =>      TILE0_TXUSRCLK21_IN,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TXN0_OUT                        =>      TILE0_TXN0_OUT,
        TXN1_OUT                        =>      TILE0_TXN1_OUT,
        TXP0_OUT                        =>      TILE0_TXP0_OUT,
        TXP1_OUT                        =>      TILE0_TXP1_OUT,
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TXENPRBSTST0_IN                 =>      TILE0_TXENPRBSTST0_IN,
        TXENPRBSTST1_IN                 =>      TILE0_TXENPRBSTST1_IN,
        TXPRBSFORCEERR0_IN              =>      TILE0_TXPRBSFORCEERR0_IN,
        TXPRBSFORCEERR1_IN              =>      TILE0_TXPRBSFORCEERR1_IN

    );


    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE1  (X1_Y0)

    tile1_ser40a_i : ser40a_tile
    generic map
    (
        -- Simulation attributes
        TILE_SIM_GTPRESET_SPEEDUP    => WRAPPER_SIM_GTPRESET_SPEEDUP,
        TILE_CLK25_DIVIDER_0         => WRAPPER_CLK25_DIVIDER_0,
        TILE_CLK25_DIVIDER_1         => WRAPPER_CLK25_DIVIDER_1,
        TILE_PLL_DIVSEL_FB_0         => WRAPPER_PLL_DIVSEL_FB_0,
        TILE_PLL_DIVSEL_FB_1         => WRAPPER_PLL_DIVSEL_FB_1,
        TILE_PLL_DIVSEL_REF_0        => WRAPPER_PLL_DIVSEL_REF_0,
        TILE_PLL_DIVSEL_REF_1        => WRAPPER_PLL_DIVSEL_REF_1,
        
        -- 
        TILE_PLL_SOURCE_0            => "PLL0",
        TILE_PLL_SOURCE_1            => "PLL0"
    )
    port map
    (
        --------------------------------- PLL Ports --------------------------------
        CLK00_IN                        =>      TILE1_CLK00_IN,
        CLK01_IN                        =>      TILE1_CLK01_IN,
        GTPRESET0_IN                    =>      TILE1_GTPRESET0_IN,
        GTPRESET1_IN                    =>      TILE1_GTPRESET1_IN,
        PLLLKDET0_OUT                   =>      tile1_plllkdet0_i,
        PLLLKDET1_OUT                   =>      tile1_plllkdet1_i,
        RESETDONE0_OUT                  =>      TILE1_RESETDONE0_OUT,
        RESETDONE1_OUT                  =>      TILE1_RESETDONE1_OUT,
        ------------------- Receive Ports - RX Data Path interface -----------------
        RXUSRCLK0_IN                    =>      TILE1_RXUSRCLK0_IN,
        RXUSRCLK1_IN                    =>      TILE1_RXUSRCLK1_IN,
        RXUSRCLK20_IN                   =>      TILE1_RXUSRCLK20_IN,
        RXUSRCLK21_IN                   =>      TILE1_RXUSRCLK21_IN,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        RXEQMIX0_IN                     =>      TILE1_RXEQMIX0_IN,
        RXEQMIX1_IN                     =>      TILE1_RXEQMIX1_IN,
        ---------------------------- TX/RX Datapath Ports --------------------------
        GTPCLKOUT0_OUT                  =>      TILE1_GTPCLKOUT0_OUT,
        GTPCLKOUT1_OUT                  =>      TILE1_GTPCLKOUT1_OUT,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TXDATA0_IN                      =>      TILE1_TXDATA0_IN,
        TXDATA1_IN                      =>      TILE1_TXDATA1_IN,
        TXOUTCLK0_OUT                   =>      TILE1_TXOUTCLK0_OUT,
        TXOUTCLK1_OUT                   =>      TILE1_TXOUTCLK1_OUT,
        TXUSRCLK0_IN                    =>      TILE1_TXUSRCLK0_IN,
        TXUSRCLK1_IN                    =>      TILE1_TXUSRCLK1_IN,
        TXUSRCLK20_IN                   =>      TILE1_TXUSRCLK20_IN,
        TXUSRCLK21_IN                   =>      TILE1_TXUSRCLK21_IN,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TXN0_OUT                        =>      TILE1_TXN0_OUT,
        TXN1_OUT                        =>      TILE1_TXN1_OUT,
        TXP0_OUT                        =>      TILE1_TXP0_OUT,
        TXP1_OUT                        =>      TILE1_TXP1_OUT,
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TXENPRBSTST0_IN                 =>      TILE1_TXENPRBSTST0_IN,
        TXENPRBSTST1_IN                 =>      TILE1_TXENPRBSTST1_IN,
        TXPRBSFORCEERR0_IN              =>      TILE1_TXPRBSFORCEERR0_IN,
        TXPRBSFORCEERR1_IN              =>      TILE1_TXPRBSFORCEERR1_IN

    );


    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE2  (X0_Y1)

    tile2_ser40a_i : ser40a_tile
    generic map
    (
        -- Simulation attributes
        TILE_SIM_GTPRESET_SPEEDUP    => WRAPPER_SIM_GTPRESET_SPEEDUP,
        TILE_CLK25_DIVIDER_0         => WRAPPER_CLK25_DIVIDER_0,
        TILE_CLK25_DIVIDER_1         => WRAPPER_CLK25_DIVIDER_1,
        TILE_PLL_DIVSEL_FB_0         => WRAPPER_PLL_DIVSEL_FB_0,
        TILE_PLL_DIVSEL_FB_1         => WRAPPER_PLL_DIVSEL_FB_1,
        TILE_PLL_DIVSEL_REF_0        => WRAPPER_PLL_DIVSEL_REF_0,
        TILE_PLL_DIVSEL_REF_1        => WRAPPER_PLL_DIVSEL_REF_1,
        
        -- 
        TILE_PLL_SOURCE_0            => "PLL0",
        TILE_PLL_SOURCE_1            => "PLL0"
    )
    port map
    (
        --------------------------------- PLL Ports --------------------------------
        CLK00_IN                        =>      TILE2_CLK00_IN,
        CLK01_IN                        =>      TILE2_CLK01_IN,
        GTPRESET0_IN                    =>      TILE2_GTPRESET0_IN,
        GTPRESET1_IN                    =>      TILE2_GTPRESET1_IN,
        PLLLKDET0_OUT                   =>      tile2_plllkdet0_i,
        PLLLKDET1_OUT                   =>      tile2_plllkdet1_i,
        RESETDONE0_OUT                  =>      TILE2_RESETDONE0_OUT,
        RESETDONE1_OUT                  =>      TILE2_RESETDONE1_OUT,
        ------------------- Receive Ports - RX Data Path interface -----------------
        RXUSRCLK0_IN                    =>      TILE2_RXUSRCLK0_IN,
        RXUSRCLK1_IN                    =>      TILE2_RXUSRCLK1_IN,
        RXUSRCLK20_IN                   =>      TILE2_RXUSRCLK20_IN,
        RXUSRCLK21_IN                   =>      TILE2_RXUSRCLK21_IN,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        RXEQMIX0_IN                     =>      TILE2_RXEQMIX0_IN,
        RXEQMIX1_IN                     =>      TILE2_RXEQMIX1_IN,
        ---------------------------- TX/RX Datapath Ports --------------------------
        GTPCLKOUT0_OUT                  =>      TILE2_GTPCLKOUT0_OUT,
        GTPCLKOUT1_OUT                  =>      TILE2_GTPCLKOUT1_OUT,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TXDATA0_IN                      =>      TILE2_TXDATA0_IN,
        TXDATA1_IN                      =>      TILE2_TXDATA1_IN,
        TXOUTCLK0_OUT                   =>      TILE2_TXOUTCLK0_OUT,
        TXOUTCLK1_OUT                   =>      TILE2_TXOUTCLK1_OUT,
        TXUSRCLK0_IN                    =>      TILE2_TXUSRCLK0_IN,
        TXUSRCLK1_IN                    =>      TILE2_TXUSRCLK1_IN,
        TXUSRCLK20_IN                   =>      TILE2_TXUSRCLK20_IN,
        TXUSRCLK21_IN                   =>      TILE2_TXUSRCLK21_IN,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TXN0_OUT                        =>      TILE2_TXN0_OUT,
        TXN1_OUT                        =>      TILE2_TXN1_OUT,
        TXP0_OUT                        =>      TILE2_TXP0_OUT,
        TXP1_OUT                        =>      TILE2_TXP1_OUT,
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TXENPRBSTST0_IN                 =>      TILE2_TXENPRBSTST0_IN,
        TXENPRBSTST1_IN                 =>      TILE2_TXENPRBSTST1_IN,
        TXPRBSFORCEERR0_IN              =>      TILE2_TXPRBSFORCEERR0_IN,
        TXPRBSFORCEERR1_IN              =>      TILE2_TXPRBSFORCEERR1_IN

    );


    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE3  (X1_Y1)

    tile3_ser40a_i : ser40a_tile
    generic map
    (
        -- Simulation attributes
        TILE_SIM_GTPRESET_SPEEDUP    => WRAPPER_SIM_GTPRESET_SPEEDUP,
        TILE_CLK25_DIVIDER_0         => WRAPPER_CLK25_DIVIDER_0,
        TILE_CLK25_DIVIDER_1         => WRAPPER_CLK25_DIVIDER_1,
        TILE_PLL_DIVSEL_FB_0         => WRAPPER_PLL_DIVSEL_FB_0,
        TILE_PLL_DIVSEL_FB_1         => WRAPPER_PLL_DIVSEL_FB_1,
        TILE_PLL_DIVSEL_REF_0        => WRAPPER_PLL_DIVSEL_REF_0,
        TILE_PLL_DIVSEL_REF_1        => WRAPPER_PLL_DIVSEL_REF_1,
        
        -- 
        TILE_PLL_SOURCE_0            => "PLL0",
        TILE_PLL_SOURCE_1            => "PLL0"
    )
    port map
    (
        --------------------------------- PLL Ports --------------------------------
        CLK00_IN                        =>      TILE3_CLK00_IN,
        CLK01_IN                        =>      TILE3_CLK01_IN,
        GTPRESET0_IN                    =>      TILE3_GTPRESET0_IN,
        GTPRESET1_IN                    =>      TILE3_GTPRESET1_IN,
        PLLLKDET0_OUT                   =>      tile3_plllkdet0_i,
        PLLLKDET1_OUT                   =>      tile3_plllkdet1_i,
        RESETDONE0_OUT                  =>      TILE3_RESETDONE0_OUT,
        RESETDONE1_OUT                  =>      TILE3_RESETDONE1_OUT,
        ------------------- Receive Ports - RX Data Path interface -----------------
        RXUSRCLK0_IN                    =>      TILE3_RXUSRCLK0_IN,
        RXUSRCLK1_IN                    =>      TILE3_RXUSRCLK1_IN,
        RXUSRCLK20_IN                   =>      TILE3_RXUSRCLK20_IN,
        RXUSRCLK21_IN                   =>      TILE3_RXUSRCLK21_IN,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        RXEQMIX0_IN                     =>      TILE3_RXEQMIX0_IN,
        RXEQMIX1_IN                     =>      TILE3_RXEQMIX1_IN,
        ---------------------------- TX/RX Datapath Ports --------------------------
        GTPCLKOUT0_OUT                  =>      TILE3_GTPCLKOUT0_OUT,
        GTPCLKOUT1_OUT                  =>      TILE3_GTPCLKOUT1_OUT,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TXDATA0_IN                      =>      TILE3_TXDATA0_IN,
        TXDATA1_IN                      =>      TILE3_TXDATA1_IN,
        TXOUTCLK0_OUT                   =>      TILE3_TXOUTCLK0_OUT,
        TXOUTCLK1_OUT                   =>      TILE3_TXOUTCLK1_OUT,
        TXUSRCLK0_IN                    =>      TILE3_TXUSRCLK0_IN,
        TXUSRCLK1_IN                    =>      TILE3_TXUSRCLK1_IN,
        TXUSRCLK20_IN                   =>      TILE3_TXUSRCLK20_IN,
        TXUSRCLK21_IN                   =>      TILE3_TXUSRCLK21_IN,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TXN0_OUT                        =>      TILE3_TXN0_OUT,
        TXN1_OUT                        =>      TILE3_TXN1_OUT,
        TXP0_OUT                        =>      TILE3_TXP0_OUT,
        TXP1_OUT                        =>      TILE3_TXP1_OUT,
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TXENPRBSTST0_IN                 =>      TILE3_TXENPRBSTST0_IN,
        TXENPRBSTST1_IN                 =>      TILE3_TXENPRBSTST1_IN,
        TXPRBSFORCEERR0_IN              =>      TILE3_TXPRBSFORCEERR0_IN,
        TXPRBSFORCEERR1_IN              =>      TILE3_TXPRBSFORCEERR1_IN

    );

     
end RTL;
