------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 1.11
--  \   \         Application : Spartan-6 FPGA GTP Transceiver Wizard  
--  /   /         Filename : instantiation_template.vhd
-- /___/   /\       
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Instantiation Template
-- Generated by Xilinx Spartan-6 FPGA GTP Transceiver Wizard
-- 
-- 
-- (c) Copyright 2009 - 2011 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


-- Use the templates in this file to add the components generated by the wizard to your
-- design.

--**************************Component Declarations*****************************


component ser40a 
generic
(
    -- Simulation attributes  
    WRAPPER_SIM_GTPRESET_SPEEDUP    : integer   := 0; -- Set to 1 to speed up sim reset
    WRAPPER_SIMULATION              : integer   := 0  -- Set to 1 for simulation  
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE0  (X0_Y0)

 
    --------------------------------- PLL Ports --------------------------------
    TILE0_CLK00_IN                          : in   std_logic;
    TILE0_CLK01_IN                          : in   std_logic;
    TILE0_GTPRESET0_IN                      : in   std_logic;
    TILE0_GTPRESET1_IN                      : in   std_logic;
    TILE0_PLLLKDET0_OUT                     : out  std_logic;
    TILE0_RESETDONE0_OUT                    : out  std_logic;
    TILE0_RESETDONE1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE0_RXUSRCLK0_IN                      : in   std_logic;
    TILE0_RXUSRCLK1_IN                      : in   std_logic;
    TILE0_RXUSRCLK20_IN                     : in   std_logic;
    TILE0_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE0_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE0_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE0_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE0_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE0_TXDATA0_IN                        : in   std_logic_vector(39 downto 0);
    TILE0_TXDATA1_IN                        : in   std_logic_vector(39 downto 0);
    TILE0_TXOUTCLK0_OUT                     : out  std_logic;
    TILE0_TXOUTCLK1_OUT                     : out  std_logic;
    TILE0_TXUSRCLK0_IN                      : in   std_logic;
    TILE0_TXUSRCLK1_IN                      : in   std_logic;
    TILE0_TXUSRCLK20_IN                     : in   std_logic;
    TILE0_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE0_TXN0_OUT                          : out  std_logic;
    TILE0_TXN1_OUT                          : out  std_logic;
    TILE0_TXP0_OUT                          : out  std_logic;
    TILE0_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE0_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE0_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE0_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE0_TXPRBSFORCEERR1_IN                : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE1  (X1_Y0)

 
    --------------------------------- PLL Ports --------------------------------
    TILE1_CLK00_IN                          : in   std_logic;
    TILE1_CLK01_IN                          : in   std_logic;
    TILE1_GTPRESET0_IN                      : in   std_logic;
    TILE1_GTPRESET1_IN                      : in   std_logic;
    TILE1_PLLLKDET0_OUT                     : out  std_logic;
    TILE1_RESETDONE0_OUT                    : out  std_logic;
    TILE1_RESETDONE1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE1_RXUSRCLK0_IN                      : in   std_logic;
    TILE1_RXUSRCLK1_IN                      : in   std_logic;
    TILE1_RXUSRCLK20_IN                     : in   std_logic;
    TILE1_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE1_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE1_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE1_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE1_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE1_TXDATA0_IN                        : in   std_logic_vector(39 downto 0);
    TILE1_TXDATA1_IN                        : in   std_logic_vector(39 downto 0);
    TILE1_TXOUTCLK0_OUT                     : out  std_logic;
    TILE1_TXOUTCLK1_OUT                     : out  std_logic;
    TILE1_TXUSRCLK0_IN                      : in   std_logic;
    TILE1_TXUSRCLK1_IN                      : in   std_logic;
    TILE1_TXUSRCLK20_IN                     : in   std_logic;
    TILE1_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE1_TXN0_OUT                          : out  std_logic;
    TILE1_TXN1_OUT                          : out  std_logic;
    TILE1_TXP0_OUT                          : out  std_logic;
    TILE1_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE1_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE1_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE1_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE1_TXPRBSFORCEERR1_IN                : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE2  (X0_Y1)

 
    --------------------------------- PLL Ports --------------------------------
    TILE2_CLK00_IN                          : in   std_logic;
    TILE2_CLK01_IN                          : in   std_logic;
    TILE2_GTPRESET0_IN                      : in   std_logic;
    TILE2_GTPRESET1_IN                      : in   std_logic;
    TILE2_PLLLKDET0_OUT                     : out  std_logic;
    TILE2_RESETDONE0_OUT                    : out  std_logic;
    TILE2_RESETDONE1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE2_RXUSRCLK0_IN                      : in   std_logic;
    TILE2_RXUSRCLK1_IN                      : in   std_logic;
    TILE2_RXUSRCLK20_IN                     : in   std_logic;
    TILE2_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE2_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE2_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE2_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE2_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE2_TXDATA0_IN                        : in   std_logic_vector(39 downto 0);
    TILE2_TXDATA1_IN                        : in   std_logic_vector(39 downto 0);
    TILE2_TXOUTCLK0_OUT                     : out  std_logic;
    TILE2_TXOUTCLK1_OUT                     : out  std_logic;
    TILE2_TXUSRCLK0_IN                      : in   std_logic;
    TILE2_TXUSRCLK1_IN                      : in   std_logic;
    TILE2_TXUSRCLK20_IN                     : in   std_logic;
    TILE2_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE2_TXN0_OUT                          : out  std_logic;
    TILE2_TXN1_OUT                          : out  std_logic;
    TILE2_TXP0_OUT                          : out  std_logic;
    TILE2_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE2_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE2_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE2_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE2_TXPRBSFORCEERR1_IN                : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE3  (X1_Y1)

 
    --------------------------------- PLL Ports --------------------------------
    TILE3_CLK00_IN                          : in   std_logic;
    TILE3_CLK01_IN                          : in   std_logic;
    TILE3_GTPRESET0_IN                      : in   std_logic;
    TILE3_GTPRESET1_IN                      : in   std_logic;
    TILE3_PLLLKDET0_OUT                     : out  std_logic;
    TILE3_RESETDONE0_OUT                    : out  std_logic;
    TILE3_RESETDONE1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE3_RXUSRCLK0_IN                      : in   std_logic;
    TILE3_RXUSRCLK1_IN                      : in   std_logic;
    TILE3_RXUSRCLK20_IN                     : in   std_logic;
    TILE3_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE3_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE3_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE3_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE3_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE3_TXDATA0_IN                        : in   std_logic_vector(39 downto 0);
    TILE3_TXDATA1_IN                        : in   std_logic_vector(39 downto 0);
    TILE3_TXOUTCLK0_OUT                     : out  std_logic;
    TILE3_TXOUTCLK1_OUT                     : out  std_logic;
    TILE3_TXUSRCLK0_IN                      : in   std_logic;
    TILE3_TXUSRCLK1_IN                      : in   std_logic;
    TILE3_TXUSRCLK20_IN                     : in   std_logic;
    TILE3_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE3_TXN0_OUT                          : out  std_logic;
    TILE3_TXN1_OUT                          : out  std_logic;
    TILE3_TXP0_OUT                          : out  std_logic;
    TILE3_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE3_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE3_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE3_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE3_TXPRBSFORCEERR1_IN                : in   std_logic


);
end component;






    ----------------------------- The GTP Wrapper -----------------------------


    ser40a_i : ser40a
    generic map
    (
        WRAPPER_SIM_GTPRESET_SPEEDUP    =>      0,    // Set this to 1 for simulation
        WRAPPER_SIMULATION              =>      0    // Set this to 1 for simulation
    )
    port map
    (
        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE0  (X0_Y0)
 
        --------------------------------- PLL Ports --------------------------------
        TILE0_CLK00_IN                  =>      tile3_gtp0_refclk_i,
        TILE0_CLK01_IN                  =>      tied_to_ground_i,
        TILE0_GTPRESET0_IN              =>      ,
        TILE0_GTPRESET1_IN              =>      ,
        TILE0_PLLLKDET0_OUT             =>      ,
        TILE0_RESETDONE0_OUT            =>      ,
        TILE0_RESETDONE1_OUT            =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE0_RXUSRCLK0_IN              =>      ,
        TILE0_RXUSRCLK1_IN              =>      ,
        TILE0_RXUSRCLK20_IN             =>      ,
        TILE0_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE0_RXEQMIX0_IN               =>      ,
        TILE0_RXEQMIX1_IN               =>      ,
        ---------------------------- TX/RX Datapath Ports --------------------------
        TILE0_GTPCLKOUT0_OUT            =>      ,
        TILE0_GTPCLKOUT1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE0_TXDATA0_IN                =>      ,
        TILE0_TXDATA1_IN                =>      ,
        TILE0_TXOUTCLK0_OUT             =>      ,
        TILE0_TXOUTCLK1_OUT             =>      ,
        TILE0_TXUSRCLK0_IN              =>      ,
        TILE0_TXUSRCLK1_IN              =>      ,
        TILE0_TXUSRCLK20_IN             =>      ,
        TILE0_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE0_TXN0_OUT                  =>      ,
        TILE0_TXN1_OUT                  =>      ,
        TILE0_TXP0_OUT                  =>      ,
        TILE0_TXP1_OUT                  =>      ,
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TILE0_TXENPRBSTST0_IN           =>      ,
        TILE0_TXENPRBSTST1_IN           =>      ,
        TILE0_TXPRBSFORCEERR0_IN        =>      ,
        TILE0_TXPRBSFORCEERR1_IN        =>      ,


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE1  (X1_Y0)
 
        --------------------------------- PLL Ports --------------------------------
        TILE1_CLK00_IN                  =>      tile3_gtp0_refclk_i,
        TILE1_CLK01_IN                  =>      tied_to_ground_i,
        TILE1_GTPRESET0_IN              =>      ,
        TILE1_GTPRESET1_IN              =>      ,
        TILE1_PLLLKDET0_OUT             =>      ,
        TILE1_RESETDONE0_OUT            =>      ,
        TILE1_RESETDONE1_OUT            =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE1_RXUSRCLK0_IN              =>      ,
        TILE1_RXUSRCLK1_IN              =>      ,
        TILE1_RXUSRCLK20_IN             =>      ,
        TILE1_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE1_RXEQMIX0_IN               =>      ,
        TILE1_RXEQMIX1_IN               =>      ,
        ---------------------------- TX/RX Datapath Ports --------------------------
        TILE1_GTPCLKOUT0_OUT            =>      ,
        TILE1_GTPCLKOUT1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE1_TXDATA0_IN                =>      ,
        TILE1_TXDATA1_IN                =>      ,
        TILE1_TXOUTCLK0_OUT             =>      ,
        TILE1_TXOUTCLK1_OUT             =>      ,
        TILE1_TXUSRCLK0_IN              =>      ,
        TILE1_TXUSRCLK1_IN              =>      ,
        TILE1_TXUSRCLK20_IN             =>      ,
        TILE1_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE1_TXN0_OUT                  =>      ,
        TILE1_TXN1_OUT                  =>      ,
        TILE1_TXP0_OUT                  =>      ,
        TILE1_TXP1_OUT                  =>      ,
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TILE1_TXENPRBSTST0_IN           =>      ,
        TILE1_TXENPRBSTST1_IN           =>      ,
        TILE1_TXPRBSFORCEERR0_IN        =>      ,
        TILE1_TXPRBSFORCEERR1_IN        =>      ,


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE2  (X0_Y1)
 
        --------------------------------- PLL Ports --------------------------------
        TILE2_CLK00_IN                  =>      tile3_gtp0_refclk_i,
        TILE2_CLK01_IN                  =>      tied_to_ground_i,
        TILE2_GTPRESET0_IN              =>      ,
        TILE2_GTPRESET1_IN              =>      ,
        TILE2_PLLLKDET0_OUT             =>      ,
        TILE2_RESETDONE0_OUT            =>      ,
        TILE2_RESETDONE1_OUT            =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE2_RXUSRCLK0_IN              =>      ,
        TILE2_RXUSRCLK1_IN              =>      ,
        TILE2_RXUSRCLK20_IN             =>      ,
        TILE2_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE2_RXEQMIX0_IN               =>      ,
        TILE2_RXEQMIX1_IN               =>      ,
        ---------------------------- TX/RX Datapath Ports --------------------------
        TILE2_GTPCLKOUT0_OUT            =>      ,
        TILE2_GTPCLKOUT1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE2_TXDATA0_IN                =>      ,
        TILE2_TXDATA1_IN                =>      ,
        TILE2_TXOUTCLK0_OUT             =>      ,
        TILE2_TXOUTCLK1_OUT             =>      ,
        TILE2_TXUSRCLK0_IN              =>      ,
        TILE2_TXUSRCLK1_IN              =>      ,
        TILE2_TXUSRCLK20_IN             =>      ,
        TILE2_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE2_TXN0_OUT                  =>      ,
        TILE2_TXN1_OUT                  =>      ,
        TILE2_TXP0_OUT                  =>      ,
        TILE2_TXP1_OUT                  =>      ,
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TILE2_TXENPRBSTST0_IN           =>      ,
        TILE2_TXENPRBSTST1_IN           =>      ,
        TILE2_TXPRBSFORCEERR0_IN        =>      ,
        TILE2_TXPRBSFORCEERR1_IN        =>      ,


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE3  (X1_Y1)
 
        --------------------------------- PLL Ports --------------------------------
        TILE3_CLK00_IN                  =>      tile3_gtp0_refclk_i,
        TILE3_CLK01_IN                  =>      tied_to_ground_i,
        TILE3_GTPRESET0_IN              =>      ,
        TILE3_GTPRESET1_IN              =>      ,
        TILE3_PLLLKDET0_OUT             =>      ,
        TILE3_RESETDONE0_OUT            =>      ,
        TILE3_RESETDONE1_OUT            =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE3_RXUSRCLK0_IN              =>      ,
        TILE3_RXUSRCLK1_IN              =>      ,
        TILE3_RXUSRCLK20_IN             =>      ,
        TILE3_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE3_RXEQMIX0_IN               =>      ,
        TILE3_RXEQMIX1_IN               =>      ,
        ---------------------------- TX/RX Datapath Ports --------------------------
        TILE3_GTPCLKOUT0_OUT            =>      ,
        TILE3_GTPCLKOUT1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE3_TXDATA0_IN                =>      ,
        TILE3_TXDATA1_IN                =>      ,
        TILE3_TXOUTCLK0_OUT             =>      ,
        TILE3_TXOUTCLK1_OUT             =>      ,
        TILE3_TXUSRCLK0_IN              =>      ,
        TILE3_TXUSRCLK1_IN              =>      ,
        TILE3_TXUSRCLK20_IN             =>      ,
        TILE3_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE3_TXN0_OUT                  =>      ,
        TILE3_TXN1_OUT                  =>      ,
        TILE3_TXP0_OUT                  =>      ,
        TILE3_TXP1_OUT                  =>      ,
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TILE3_TXENPRBSTST0_IN           =>      ,
        TILE3_TXENPRBSTST1_IN           =>      ,
        TILE3_TXPRBSFORCEERR0_IN        =>      ,
        TILE3_TXPRBSFORCEERR1_IN        =>      


    );


    -----------------------Dedicated GTP Reference Clock Inputs ---------------
    -- Each dedicated refclk you are using in your design will need its own IBUFDS instance
    
    tile0_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile0_gtp0_refclk_i,
        I                               =>      ,  -- Connect to package pin AJ13
        IB                              =>         -- Connect to package pin AK13
    );

    tile1_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile1_gtp0_refclk_i,
        I                               =>      ,  -- Connect to package pin AG18
        IB                              =>         -- Connect to package pin AH18
    );

    tile2_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile2_gtp0_refclk_i,
        I                               =>      ,  -- Connect to package pin B13
        IB                              =>         -- Connect to package pin A13
    );

    tile3_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile3_gtp0_refclk_i,
        I                               =>      ,  -- Connect to package pin D18
        IB                              =>         -- Connect to package pin C18
    );












