`timescale 1ns / 1ps

module mpc_formatter
(
	input [7:0] tmb1_lct0_hs,
	input [6:0] tmb1_lct0_wg,
	input [3:0] tmb1_lct0_qual,
	input [3:0] tmb1_lct0_cpat,
	input       tmb1_lct0_lr,
	input       tmb1_lct0_vpf,
	input       tmb1_lct0_bc0,
	input       tmb1_lct0_bx0,
	input       tmb1_lct0_syer,
	input [3:0] tmb1_lct0_cscid,

	input [7:0] tmb1_lct1_hs,
	input [6:0] tmb1_lct1_wg,
	input [3:0] tmb1_lct1_qual,
	input [3:0] tmb1_lct1_cpat,
	input       tmb1_lct1_lr,
	input       tmb1_lct1_vpf,
	input       tmb1_lct1_bc0,
	input       tmb1_lct1_bx0,
	input       tmb1_lct1_syer,
	input [3:0] tmb1_lct1_cscid,

	input [7:0] tmb2_lct0_hs,
	input [6:0] tmb2_lct0_wg,
	input [3:0] tmb2_lct0_qual,
	input [3:0] tmb2_lct0_cpat,
	input       tmb2_lct0_lr,
	input       tmb2_lct0_vpf,
	input       tmb2_lct0_bc0,
	input       tmb2_lct0_bx0,
	input       tmb2_lct0_syer,
	input [3:0] tmb2_lct0_cscid,

	input [7:0] tmb2_lct1_hs,
	input [6:0] tmb2_lct1_wg,
	input [3:0] tmb2_lct1_qual,
	input [3:0] tmb2_lct1_cpat,
	input       tmb2_lct1_lr,
	input       tmb2_lct1_vpf,
	input       tmb2_lct1_bc0,
	input       tmb2_lct1_bx0,
	input       tmb2_lct1_syer,
	input [3:0] tmb2_lct1_cscid,

	input [7:0] tmb3_lct0_hs,
	input [6:0] tmb3_lct0_wg,
	input [3:0] tmb3_lct0_qual,
	input [3:0] tmb3_lct0_cpat,
	input       tmb3_lct0_lr,
	input       tmb3_lct0_vpf,
	input       tmb3_lct0_bc0,
	input       tmb3_lct0_bx0,
	input       tmb3_lct0_syer,
	input [3:0] tmb3_lct0_cscid,

	input [7:0] tmb3_lct1_hs,
	input [6:0] tmb3_lct1_wg,
	input [3:0] tmb3_lct1_qual,
	input [3:0] tmb3_lct1_cpat,
	input       tmb3_lct1_lr,
	input       tmb3_lct1_vpf,
	input       tmb3_lct1_bc0,
	input       tmb3_lct1_bx0,
	input       tmb3_lct1_syer,
	input [3:0] tmb3_lct1_cscid,

	input [7:0] tmb4_lct0_hs,
	input [6:0] tmb4_lct0_wg,
	input [3:0] tmb4_lct0_qual,
	input [3:0] tmb4_lct0_cpat,
	input       tmb4_lct0_lr,
	input       tmb4_lct0_vpf,
	input       tmb4_lct0_bc0,
	input       tmb4_lct0_bx0,
	input       tmb4_lct0_syer,
	input [3:0] tmb4_lct0_cscid,

	input [7:0] tmb4_lct1_hs,
	input [6:0] tmb4_lct1_wg,
	input [3:0] tmb4_lct1_qual,
	input [3:0] tmb4_lct1_cpat,
	input       tmb4_lct1_lr,
	input       tmb4_lct1_vpf,
	input       tmb4_lct1_bc0,
	input       tmb4_lct1_bx0,
	input       tmb4_lct1_syer,
	input [3:0] tmb4_lct1_cscid,

	input [7:0] tmb5_lct0_hs,
	input [6:0] tmb5_lct0_wg,
	input [3:0] tmb5_lct0_qual,
	input [3:0] tmb5_lct0_cpat,
	input       tmb5_lct0_lr,
	input       tmb5_lct0_vpf,
	input       tmb5_lct0_bc0,
	input       tmb5_lct0_bx0,
	input       tmb5_lct0_syer,
	input [3:0] tmb5_lct0_cscid,

	input [7:0] tmb5_lct1_hs,
	input [6:0] tmb5_lct1_wg,
	input [3:0] tmb5_lct1_qual,
	input [3:0] tmb5_lct1_cpat,
	input       tmb5_lct1_lr,
	input       tmb5_lct1_vpf,
	input       tmb5_lct1_bc0,
	input       tmb5_lct1_bx0,
	input       tmb5_lct1_syer,
	input [3:0] tmb5_lct1_cscid,

	input [7:0] tmb6_lct0_hs,
	input [6:0] tmb6_lct0_wg,
	input [3:0] tmb6_lct0_qual,
	input [3:0] tmb6_lct0_cpat,
	input       tmb6_lct0_lr,
	input       tmb6_lct0_vpf,
	input       tmb6_lct0_bc0,
	input       tmb6_lct0_bx0,
	input       tmb6_lct0_syer,
	input [3:0] tmb6_lct0_cscid,

	input [7:0] tmb6_lct1_hs,
	input [6:0] tmb6_lct1_wg,
	input [3:0] tmb6_lct1_qual,
	input [3:0] tmb6_lct1_cpat,
	input       tmb6_lct1_lr,
	input       tmb6_lct1_vpf,
	input       tmb6_lct1_bc0,
	input       tmb6_lct1_bx0,
	input       tmb6_lct1_syer,
	input [3:0] tmb6_lct1_cscid,

	input [7:0] tmb7_lct0_hs,
	input [6:0] tmb7_lct0_wg,
	input [3:0] tmb7_lct0_qual,
	input [3:0] tmb7_lct0_cpat,
	input       tmb7_lct0_lr,
	input       tmb7_lct0_vpf,
	input       tmb7_lct0_bc0,
	input       tmb7_lct0_bx0,
	input       tmb7_lct0_syer,
	input [3:0] tmb7_lct0_cscid,

	input [7:0] tmb7_lct1_hs,
	input [6:0] tmb7_lct1_wg,
	input [3:0] tmb7_lct1_qual,
	input [3:0] tmb7_lct1_cpat,
	input       tmb7_lct1_lr,
	input       tmb7_lct1_vpf,
	input       tmb7_lct1_bc0,
	input       tmb7_lct1_bx0,
	input       tmb7_lct1_syer,
	input [3:0] tmb7_lct1_cscid,

	input [7:0] tmb8_lct0_hs,
	input [6:0] tmb8_lct0_wg,
	input [3:0] tmb8_lct0_qual,
	input [3:0] tmb8_lct0_cpat,
	input       tmb8_lct0_lr,
	input       tmb8_lct0_vpf,
	input       tmb8_lct0_bc0,
	input       tmb8_lct0_bx0,
	input       tmb8_lct0_syer,
	input [3:0] tmb8_lct0_cscid,

	input [7:0] tmb8_lct1_hs,
	input [6:0] tmb8_lct1_wg,
	input [3:0] tmb8_lct1_qual,
	input [3:0] tmb8_lct1_cpat,
	input       tmb8_lct1_lr,
	input       tmb8_lct1_vpf,
	input       tmb8_lct1_bc0,
	input       tmb8_lct1_bx0,
	input       tmb8_lct1_syer,
	input [3:0] tmb8_lct1_cscid,

	input [7:0] tmb9_lct0_hs,
	input [6:0] tmb9_lct0_wg,
	input [3:0] tmb9_lct0_qual,
	input [3:0] tmb9_lct0_cpat,
	input       tmb9_lct0_lr,
	input       tmb9_lct0_vpf,
	input       tmb9_lct0_bc0,
	input       tmb9_lct0_bx0,
	input       tmb9_lct0_syer,
	input [3:0] tmb9_lct0_cscid,

	input [7:0] tmb9_lct1_hs,
	input [6:0] tmb9_lct1_wg,
	input [3:0] tmb9_lct1_qual,
	input [3:0] tmb9_lct1_cpat,
	input       tmb9_lct1_lr,
	input       tmb9_lct1_vpf,
	input       tmb9_lct1_bc0,
	input       tmb9_lct1_bx0,
	input       tmb9_lct1_syer,
	input [3:0] tmb9_lct1_cscid,

	output [75:0] link0_tx_data,
	output [75:0] link1_tx_data,
	output [75:0] link2_tx_data,
	output [75:0] link3_tx_data,
	output [75:0] link4_tx_data,
	output [75:0] link5_tx_data,
	output [75:0] link6_tx_data,
	output [75:0] link7_tx_data,
	
	input [5:0] mpc_id,
	
	input clk40

);

	wire [75:0] txd [7:0];
	reg  [2:0] crc [7:0];
	reg  [75:0] link_id [7:0];

	// logic is as follows:
	// if there's any valid LCT or BC0 to be transmitted in each link, then transmit encoded data
	// otherwise transmit link_id + test pattern
	// BC0 signals are taken only from LCT0 from each chamber. LCT1 BC0 is the same signal, will be repurposed in TMB

	assign link0_tx_data = 
								  (tmb2_lct1_vpf || tmb2_lct0_vpf || tmb1_lct0_vpf || tmb2_lct0_bc0 || tmb1_lct0_bc0) ? txd[0] :
								  link_id[0];

	assign link1_tx_data = 
								  (tmb3_lct1_vpf || tmb3_lct0_vpf || tmb1_lct0_vpf || tmb3_lct0_bc0 || tmb1_lct0_bc0) ? txd[1] :
								  link_id[1];

	assign link2_tx_data = 
								  (tmb4_lct1_vpf || tmb4_lct0_vpf || tmb1_lct0_vpf || tmb4_lct0_bc0 || tmb1_lct0_bc0) ? txd[2] :
								  link_id[2];

	assign link3_tx_data = 
								  (tmb5_lct1_vpf || tmb5_lct0_vpf || tmb1_lct0_vpf || tmb5_lct0_bc0 || tmb1_lct0_bc0) ? txd[3] :
								  link_id[3];

	assign link4_tx_data = 
								  (tmb6_lct1_vpf || tmb6_lct0_vpf || tmb1_lct1_vpf || tmb6_lct0_bc0 || tmb1_lct0_bc0) ? txd[4] :
								  link_id[4];

	assign link5_tx_data = 
								  (tmb7_lct1_vpf || tmb7_lct0_vpf || tmb1_lct1_vpf || tmb7_lct0_bc0 || tmb1_lct0_bc0) ? txd[5] :
								  link_id[5];

	assign link6_tx_data = 
								  (tmb8_lct1_vpf || tmb8_lct0_vpf || tmb1_lct1_vpf || tmb8_lct0_bc0 || tmb1_lct0_bc0) ? txd[6] :
								  link_id[6];

	assign link7_tx_data = 
								  (tmb9_lct1_vpf || tmb9_lct0_vpf || tmb1_lct1_vpf || tmb9_lct0_bc0 || tmb1_lct0_bc0) ? txd[7] :
								  link_id[7];

	
	assign txd[0] = 
	{
	
		crc [0][2],
		tmb1_lct0_bc0,
		tmb1_lct0_hs[7:4],
	
		tmb2_lct1_cscid,
		tmb2_lct1_syer,
		tmb2_lct1_bx0,
		tmb2_lct1_bc0,
		tmb2_lct1_vpf,
		tmb2_lct1_lr,
		tmb2_lct1_cpat,
		tmb2_lct1_qual,
		tmb2_lct1_wg,
		tmb2_lct1_hs,
	
		crc [0][1:0],
		tmb1_lct0_hs[3:0],
	
		tmb2_lct0_cscid,
		tmb2_lct0_syer,
		tmb2_lct0_bx0,
		tmb2_lct0_bc0,
		tmb2_lct0_vpf,
		tmb2_lct0_lr,
		tmb2_lct0_cpat,
		tmb2_lct0_qual,
		tmb2_lct0_wg,
		tmb2_lct0_hs
	};

	assign txd[1] = 
	{
	
		crc [1][2],
		tmb1_lct0_bc0,
		tmb1_lct0_lr,
		tmb1_lct0_wg[6:4],

		tmb3_lct1_cscid,
		tmb3_lct1_syer,
		tmb3_lct1_bx0,
		tmb3_lct1_bc0,
		tmb3_lct1_vpf,
		tmb3_lct1_lr,
		tmb3_lct1_cpat,
		tmb3_lct1_qual,
		tmb3_lct1_wg,
		tmb3_lct1_hs,
	
		crc [1][1:0],
		tmb1_lct0_wg[3:0],

		tmb3_lct0_cscid,
		tmb3_lct0_syer,
		tmb3_lct0_bx0,
		tmb3_lct0_bc0,
		tmb3_lct0_vpf,
		tmb3_lct0_lr,
		tmb3_lct0_cpat,
		tmb3_lct0_qual,
		tmb3_lct0_wg,
		tmb3_lct0_hs
	};

	assign txd[2] = 
	{
	
		crc [2][2],
		tmb1_lct0_bc0,
		tmb1_lct0_cpat,

		tmb4_lct1_cscid,
		tmb4_lct1_syer,
		tmb4_lct1_bx0,
		tmb4_lct1_bc0,
		tmb4_lct1_vpf,
		tmb4_lct1_lr,
		tmb4_lct1_cpat,
		tmb4_lct1_qual,
		tmb4_lct1_wg,
		tmb4_lct1_hs,
	
		crc [2][1:0],
		tmb1_lct0_qual,

		tmb4_lct0_cscid,
		tmb4_lct0_syer,
		tmb4_lct0_bx0,
		tmb4_lct0_bc0,
		tmb4_lct0_vpf,
		tmb4_lct0_lr,
		tmb4_lct0_cpat,
		tmb4_lct0_qual,
		tmb4_lct0_wg,
		tmb4_lct0_hs
	};

	assign txd[3] = 
	{
	
		crc [3][2],
		tmb1_lct0_bc0,
		tmb1_lct0_syer,
		tmb1_lct0_bx0,
		1'b0,
		tmb1_lct0_vpf,

		tmb5_lct1_cscid,
		tmb5_lct1_syer,
		tmb5_lct1_bx0,
		tmb5_lct1_bc0,
		tmb5_lct1_vpf,
		tmb5_lct1_lr,
		tmb5_lct1_cpat,
		tmb5_lct1_qual,
		tmb5_lct1_wg,
		tmb5_lct1_hs,
	
		crc [3][1:0],
		tmb1_lct0_cscid,

		tmb5_lct0_cscid,
		tmb5_lct0_syer,
		tmb5_lct0_bx0,
		tmb5_lct0_bc0,
		tmb5_lct0_vpf,
		tmb5_lct0_lr,
		tmb5_lct0_cpat,
		tmb5_lct0_qual,
		tmb5_lct0_wg,
		tmb5_lct0_hs
	};

	assign txd[4] = 
	{
	
		crc [4][2],
		tmb1_lct1_bc0,
		tmb1_lct1_hs[7:4],

		tmb6_lct1_cscid,
		tmb6_lct1_syer,
		tmb6_lct1_bx0,
		tmb6_lct1_bc0,
		tmb6_lct1_vpf,
		tmb6_lct1_lr,
		tmb6_lct1_cpat,
		tmb6_lct1_qual,
		tmb6_lct1_wg,
		tmb6_lct1_hs,
	
		crc [4][1:0],
		tmb1_lct1_hs[3:0],
	
		tmb6_lct0_cscid,
		tmb6_lct0_syer,
		tmb6_lct0_bx0,
		tmb6_lct0_bc0,
		tmb6_lct0_vpf,
		tmb6_lct0_lr,
		tmb6_lct0_cpat,
		tmb6_lct0_qual,
		tmb6_lct0_wg,
		tmb6_lct0_hs
	};

	assign txd[5] = 
	{
		crc [5][2],
		tmb1_lct1_bc0,
		tmb1_lct1_lr,
		tmb1_lct1_wg[6:4],

		tmb7_lct1_cscid,
		tmb7_lct1_syer,
		tmb7_lct1_bx0,
		tmb7_lct1_bc0,
		tmb7_lct1_vpf,
		tmb7_lct1_lr,
		tmb7_lct1_cpat,
		tmb7_lct1_qual,
		tmb7_lct1_wg,
		tmb7_lct1_hs,
	
		crc [5][1:0],
		tmb1_lct1_wg[3:0],

		tmb7_lct0_cscid,
		tmb7_lct0_syer,
		tmb7_lct0_bx0,
		tmb7_lct0_bc0,
		tmb7_lct0_vpf,
		tmb7_lct0_lr,
		tmb7_lct0_cpat,
		tmb7_lct0_qual,
		tmb7_lct0_wg,
		tmb7_lct0_hs
	};

	assign txd[6] = 
	{
	
		crc [6][2],
		tmb1_lct1_bc0,
		tmb1_lct1_cpat,

		tmb8_lct1_cscid,
		tmb8_lct1_syer,
		tmb8_lct1_bx0,
		tmb8_lct1_bc0,
		tmb8_lct1_vpf,
		tmb8_lct1_lr,
		tmb8_lct1_cpat,
		tmb8_lct1_qual,
		tmb8_lct1_wg,
		tmb8_lct1_hs,
	
		crc [6][1:0],
		tmb1_lct1_qual,

		tmb8_lct0_cscid,
		tmb8_lct0_syer,
		tmb8_lct0_bx0,
		tmb8_lct0_bc0,
		tmb8_lct0_vpf,
		tmb8_lct0_lr,
		tmb8_lct0_cpat,
		tmb8_lct0_qual,
		tmb8_lct0_wg,
		tmb8_lct0_hs
	};

	assign txd[7] = 
	{
	
		crc [7][2],
		tmb1_lct1_bc0,
		tmb1_lct1_syer,
		tmb1_lct1_bx0,
		1'b0,
		tmb1_lct1_vpf,

		tmb9_lct1_cscid,
		tmb9_lct1_syer,
		tmb9_lct1_bx0,
		tmb9_lct1_bc0,
		tmb9_lct1_vpf,
		tmb9_lct1_lr,
		tmb9_lct1_cpat,
		tmb9_lct1_qual,
		tmb9_lct1_wg,
		tmb9_lct1_hs,
	
		crc [7][1:0],
		tmb1_lct1_cscid,

		tmb9_lct0_cscid,
		tmb9_lct0_syer,
		tmb9_lct0_bx0,
		tmb9_lct0_bc0,
		tmb9_lct0_vpf,
		tmb9_lct0_lr,
		tmb9_lct0_cpat,
		tmb9_lct0_qual,
		tmb9_lct0_wg,
		tmb9_lct0_hs
	};

	reg [18:0] cnt;
	integer i, j;
	always @(*)
	begin
		for (i = 0; i < 8; i=i+1)
		begin
			// calculate crc for each link
			// these are just parity bits for chunks of 24,24,25 bits
			crc[i] = 3'b0;
			for (j =  0; j <= 23; j=j+1) crc[i][0] = crc[i][0] ^ txd[i][j];
			for (j = 24; j <= 35; j=j+1) crc[i][1] = crc[i][1] ^ txd[i][j];
			for (j = 38; j <= 49; j=j+1) crc[i][1] = crc[i][1] ^ txd[i][j];
			for (j = 50; j <= 74; j=j+1) crc[i][2] = crc[i][2] ^ txd[i][j];

			// link ID is just MPC id and link number in lower bits
			// test pattern in higher bits
			// bits with BC0 and VPF flags are filled with zeros, to avoid confusing EMTF
			link_id[i] = {19'h0, cnt, 28'h0, mpc_id, i[3:0]};
		end
	end

	
	always @(posedge clk40)
	begin
		cnt = cnt + 19'b1; // test pattern counter
	end



endmodule
