LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

ENTITY MUX64X16 IS

-- unified version 08/19/2013
-- update on 09/28/2017; DON'T USE BC0X INPUTS FOR MULTIPLEXING

    Port ( FA : in std_logic_vector(31 downto 0);
           FB : in std_logic_vector(31 downto 0);
           FC : in std_logic_vector(31 downto 0);
           FDD : in std_logic_vector(31 downto 0);
           FE : in std_logic_vector(31 downto 0);
           FF : in std_logic_vector(31 downto 0);
           FG : in std_logic_vector(31 downto 0);
           FH : in std_logic_vector(31 downto 0);
           FI : in std_logic_vector(31 downto 0);

           SA : in std_logic_vector(31 downto 0);
           SB : in std_logic_vector(31 downto 0);
           SC : in std_logic_vector(31 downto 0);
           SD : in std_logic_vector(31 downto 0);
           SE : in std_logic_vector(31 downto 0);
           SF : in std_logic_vector(31 downto 0);
           SG : in std_logic_vector(31 downto 0);
           SH : in std_logic_vector(31 downto 0);
           SI : in std_logic_vector(31 downto 0);
 
           DA : out std_logic_vector(15 downto 0);
           DB : out std_logic_vector(15 downto 0);
           DC : out std_logic_vector(15 downto 0);
           DD : out std_logic_vector(15 downto 0);
           DE : out std_logic_vector(15 downto 0);
           DF : out std_logic_vector(15 downto 0);
           DG : out std_logic_vector(15 downto 0);
           DH : out std_logic_vector(15 downto 0);
 	
           BC0A : in std_logic_vector(1 downto 0);		
           BC0B : in std_logic_vector(1 downto 0);					  
           BC0C : in std_logic_vector(1 downto 0);		
           BC0D : in std_logic_vector(1 downto 0);		
           BC0E : in std_logic_vector(1 downto 0);		
           BC0F : in std_logic_vector(1 downto 0);					  
           BC0G : in std_logic_vector(1 downto 0);		
           BC0H : in std_logic_vector(1 downto 0);		
           BC0I : in std_logic_vector(1 downto 0);			
           BC0J : in std_logic_vector(1 downto 0);		
           BC0K : in std_logic_vector(1 downto 0);					  
           BC0L : in std_logic_vector(1 downto 0);		
           BC0M : in std_logic_vector(1 downto 0);		
           BC0N : in std_logic_vector(1 downto 0);		
           BC0P : in std_logic_vector(1 downto 0);					  
           BC0Q : in std_logic_vector(1 downto 0);		
           BC0R : in std_logic_vector(1 downto 0);		
           BC0S : in std_logic_vector(1 downto 0);				  

           CA : in std_logic_vector(1 downto 0);			  
           CB : in std_logic_vector(1 downto 0);					  
           CC : in std_logic_vector(1 downto 0);			  
           CD : in std_logic_vector(1 downto 0);				  
           CE : in std_logic_vector(1 downto 0);			  
           CF : in std_logic_vector(1 downto 0);					  
           CG : in std_logic_vector(1 downto 0);			  
           CH : in std_logic_vector(1 downto 0);	
           CI : in std_logic_vector(1 downto 0);	
           CJ : in std_logic_vector(1 downto 0);			  
           CK : in std_logic_vector(1 downto 0);					  
           CL : in std_logic_vector(1 downto 0);			  
           CM : in std_logic_vector(1 downto 0);				  
           CN : in std_logic_vector(1 downto 0);			  
           CP : in std_logic_vector(1 downto 0);					  
           CQ : in std_logic_vector(1 downto 0);			  
           CR : in std_logic_vector(1 downto 0);	
           CS : in std_logic_vector(1 downto 0);

           FFRAME : in std_logic;
			  SFRAME : in std_logic;
			  TFRAME : in std_logic;
			  FOFRAME : in std_logic;
			  POS : in std_logic;
           NEG : in std_logic		  
			  
 );

END ENTITY MUX64X16;

ARCHITECTURE ARC OF MUX64X16 IS

BEGIN

-- LINK 1  -- DONE
-- original bits 8-15
--DA(8) <= (FA(16) AND FOFRAME) OR (SB(24) AND TFRAME) OR (FB(0) AND SFRAME) OR (FB(16) AND FFRAME); 
--DA(9) <= (FA(17) AND FOFRAME) OR (SB(8) AND TFRAME) OR (FB(1) AND SFRAME) OR (FB(17) AND FFRAME); 
--DA(10) <= (FA(18) AND FOFRAME) OR (FB(31) AND TFRAME) OR (FB(2) AND SFRAME) OR (FB(18) AND FFRAME); 
--DA(11) <= (FA(19) AND FOFRAME) OR (FB(15) AND TFRAME) OR (FB(3) AND SFRAME) OR (FB(19) AND FFRAME); 
--DA(12) <= (FA(20) AND FOFRAME) OR (SB(27) AND TFRAME) OR (FB(4) AND SFRAME) OR (FB(20) AND FFRAME); 
--DA(13) <= (FA(21) AND FOFRAME) OR (SA(27) AND TFRAME) OR (FB(5) AND SFRAME) OR (FB(21) AND FFRAME); 
--DA(14) <= (FA(22) AND FOFRAME) OR (SB(25) AND TFRAME) OR (FB(6) AND SFRAME) OR (FB(22) AND FFRAME); 
DA(0) <= (FB(11) AND FOFRAME) OR (FB(27) AND TFRAME) OR (SB(0) AND SFRAME) OR (SB(16) AND FFRAME); 
DA(1) <= (FB(12) AND FOFRAME) OR (FB(28) AND TFRAME) OR (SB(1) AND SFRAME) OR (SB(17) AND FFRAME); 
DA(2) <= (FB(13) AND FOFRAME) OR (FB(29) AND TFRAME) OR (SB(2) AND SFRAME) OR (SB(18) AND FFRAME); 
DA(3) <= (FB(14) AND FOFRAME) OR (FB(30) AND TFRAME) OR (SB(3) AND SFRAME) OR (SB(19) AND FFRAME); 
DA(4) <= (FB(7) AND FOFRAME) OR (FB(23) AND TFRAME) OR (SB(4) AND SFRAME) OR (SB(20) AND FFRAME); 
DA(5) <= (FB(8) AND FOFRAME) OR (FB(24) AND TFRAME) OR (SB(5) AND SFRAME) OR (SB(21) AND FFRAME); 
DA(6) <= (FB(9) AND FOFRAME) OR (FB(25) AND TFRAME) OR (SB(6) AND SFRAME) OR (SB(22) AND FFRAME); 
DA(7) <= (FB(10) AND FOFRAME) OR (FB(26) AND TFRAME) OR (SB(7) AND SFRAME) OR (SB(23) AND FFRAME); 
DA(8) <= (SA(16) AND FOFRAME) OR (SB(24) AND TFRAME) OR (FB(0) AND SFRAME) OR (FB(16) AND FFRAME); 
DA(9) <= (SA(17) AND FOFRAME) OR (SB(8) AND TFRAME) OR (FB(1) AND SFRAME) OR (FB(17) AND FFRAME); 
DA(10) <= (SA(18) AND FOFRAME) OR (FB(31) AND TFRAME) OR (FB(2) AND SFRAME) OR (FB(18) AND FFRAME); 
DA(11) <= (SA(19) AND FOFRAME) OR (FB(15) AND TFRAME) OR (FB(3) AND SFRAME) OR (FB(19) AND FFRAME); 
DA(12) <= (SA(20) AND FOFRAME) OR (SB(27) AND TFRAME) OR (FB(4) AND SFRAME) OR (FB(20) AND FFRAME); 
DA(13) <= (SA(21) AND FOFRAME) OR (SA(27) AND TFRAME) OR (FB(5) AND SFRAME) OR (FB(21) AND FFRAME); 
DA(14) <= (SA(22) AND FOFRAME) OR (SB(25) AND TFRAME) OR (FB(6) AND SFRAME) OR (FB(22) AND FFRAME); 
DA(15) <= FFRAME; 

-- LINK 2  -- DONE
DB(0) <= (FC(11) AND FOFRAME) OR (FC(27) AND TFRAME) OR (SC(0) AND SFRAME) OR (SC(16) AND FFRAME); 
DB(1) <= (FC(12) AND FOFRAME) OR (FC(28) AND TFRAME) OR (SC(1) AND SFRAME) OR (SC(17) AND FFRAME); 
DB(2) <= (FC(13) AND FOFRAME) OR (FC(29) AND TFRAME) OR (SC(2) AND SFRAME) OR (SC(18) AND FFRAME); 
DB(3) <= (FC(14) AND FOFRAME) OR (FC(30) AND TFRAME) OR (SC(3) AND SFRAME) OR (SC(19) AND FFRAME); 
DB(4) <= (FC(7) AND FOFRAME) OR (FC(23) AND TFRAME) OR (SC(4) AND SFRAME) OR (SC(20) AND FFRAME); 
DB(5) <= (FC(8) AND FOFRAME) OR (FC(24) AND TFRAME) OR (SC(5) AND SFRAME) OR (SC(21) AND FFRAME); 
DB(6) <= (FC(9) AND FOFRAME) OR (FC(25) AND TFRAME) OR (SC(6) AND SFRAME) OR (SC(22) AND FFRAME); 
DB(7) <= (FC(10) AND FOFRAME) OR (FC(26) AND TFRAME) OR (SC(7) AND SFRAME) OR (SC(23) AND FFRAME); 
DB(8) <= (FA(0) AND FOFRAME) OR (SC(24) AND TFRAME) OR (FC(0) AND SFRAME) OR (FC(16) AND FFRAME); 
DB(9) <= (FA(1) AND FOFRAME) OR (SC(8) AND TFRAME) OR (FC(1) AND SFRAME) OR (FC(17) AND FFRAME); 
DB(10) <= (FA(2) AND FOFRAME) OR (FC(31) AND TFRAME) OR (FC(2) AND SFRAME) OR (FC(18) AND FFRAME); 
DB(11) <= (FA(3) AND FOFRAME) OR (FC(15) AND TFRAME) OR (FC(3) AND SFRAME) OR (FC(19) AND FFRAME); 
DB(12) <= (FA(4) AND FOFRAME) OR (SC(27) AND TFRAME) OR (FC(4) AND SFRAME) OR (FC(20) AND FFRAME); 
DB(13) <= (FA(5) AND FOFRAME) OR (SA(27) AND TFRAME) OR (FC(5) AND SFRAME) OR (FC(21) AND FFRAME); 
DB(14) <= (FA(6) AND FOFRAME) OR (SC(25) AND TFRAME) OR (FC(6) AND SFRAME) OR (FC(22) AND FFRAME); 
DB(15) <= FFRAME; 

-- LINK 3   -- DONE
-- original bits 8-15 (change in frame 4)
--DC(8) <= (SA(16) AND FOFRAME) OR (SD(24) AND TFRAME) OR (FDD(0) AND SFRAME) OR (FDD(16) AND FFRAME); 
--DC(9) <= (SA(17) AND FOFRAME) OR (SD(8) AND TFRAME) OR (FDD(1) AND SFRAME) OR (FDD(17) AND FFRAME); 
--DC(10) <= (SA(18) AND FOFRAME) OR (FDD(31) AND TFRAME) OR (FDD(2) AND SFRAME) OR (FDD(18) AND FFRAME); 
--DC(11) <= (SA(19) AND FOFRAME) OR (FDD(15) AND TFRAME) OR (FDD(3) AND SFRAME) OR (FDD(19) AND FFRAME); 
--DC(12) <= (SA(20) AND FOFRAME) OR (SD(27) AND TFRAME) OR (FDD(4) AND SFRAME) OR (FDD(20) AND FFRAME); 
--DC(13) <= (SA(21) AND FOFRAME) OR (SA(27) AND TFRAME) OR (FDD(5) AND SFRAME) OR (FDD(21) AND FFRAME); 
--DC(14) <= (SA(22) AND FOFRAME) OR (SD(25) AND TFRAME) OR (FDD(6) AND SFRAME) OR (FDD(22) AND FFRAME); 
DC(0) <= (FDD(11) AND FOFRAME) OR (FDD(27) AND TFRAME) OR (SD(0) AND SFRAME) OR (SD(16) AND FFRAME); 
DC(1) <= (FDD(12) AND FOFRAME) OR (FDD(28) AND TFRAME) OR (SD(1) AND SFRAME) OR (SD(17) AND FFRAME); 
DC(2) <= (FDD(13) AND FOFRAME) OR (FDD(29) AND TFRAME) OR (SD(2) AND SFRAME) OR (SD(18) AND FFRAME); 
DC(3) <= (FDD(14) AND FOFRAME) OR (FDD(30) AND TFRAME) OR (SD(3) AND SFRAME) OR (SD(19) AND FFRAME); 
DC(4) <= (FDD(7) AND FOFRAME) OR (FDD(23) AND TFRAME) OR (SD(4) AND SFRAME) OR (SD(20) AND FFRAME); 
DC(5) <= (FDD(8) AND FOFRAME) OR (FDD(24) AND TFRAME) OR (SD(5) AND SFRAME) OR (SD(21) AND FFRAME); 
DC(6) <= (FDD(9) AND FOFRAME) OR (FDD(25) AND TFRAME) OR (SD(6) AND SFRAME) OR (SD(22) AND FFRAME); 
DC(7) <= (FDD(10) AND FOFRAME) OR (FDD(26) AND TFRAME) OR (SD(7) AND SFRAME) OR (SD(23) AND FFRAME); 
DC(8) <= (FA(16) AND FOFRAME) OR (SD(24) AND TFRAME) OR (FDD(0) AND SFRAME) OR (FDD(16) AND FFRAME); 
DC(9) <= (FA(17) AND FOFRAME) OR (SD(8) AND TFRAME) OR (FDD(1) AND SFRAME) OR (FDD(17) AND FFRAME); 
DC(10) <= (FA(18) AND FOFRAME) OR (FDD(31) AND TFRAME) OR (FDD(2) AND SFRAME) OR (FDD(18) AND FFRAME); 
DC(11) <= (FA(19) AND FOFRAME) OR (FDD(15) AND TFRAME) OR (FDD(3) AND SFRAME) OR (FDD(19) AND FFRAME); 
DC(12) <= (FA(20) AND FOFRAME) OR (SD(27) AND TFRAME) OR (FDD(4) AND SFRAME) OR (FDD(20) AND FFRAME); 
DC(13) <= (FA(21) AND FOFRAME) OR (SA(27) AND TFRAME) OR (FDD(5) AND SFRAME) OR (FDD(21) AND FFRAME); 
DC(14) <= (FA(22) AND FOFRAME) OR (SD(25) AND TFRAME) OR (FDD(6) AND SFRAME) OR (FDD(22) AND FFRAME); 
DC(15) <= FFRAME; 

-- LINK 4 -- DONE
DD(0) <= (FE(11) AND FOFRAME) OR (FE(27) AND TFRAME) OR (SE(0) AND SFRAME) OR (SE(16) AND FFRAME); 
DD(1) <= (FE(12) AND FOFRAME) OR (FE(28) AND TFRAME) OR (SE(1) AND SFRAME) OR (SE(17) AND FFRAME); 
DD(2) <= (FE(13) AND FOFRAME) OR (FE(29) AND TFRAME) OR (SE(2) AND SFRAME) OR (SE(18) AND FFRAME); 
DD(3) <= (FE(14) AND FOFRAME) OR (FE(30) AND TFRAME) OR (SE(3) AND SFRAME) OR (SE(19) AND FFRAME); 
DD(4) <= (FE(7) AND FOFRAME) OR (FE(23) AND TFRAME) OR (SE(4) AND SFRAME) OR (SE(20) AND FFRAME); 
DD(5) <= (FE(8) AND FOFRAME) OR (FE(24) AND TFRAME) OR (SE(5) AND SFRAME) OR (SE(21) AND FFRAME); 
DD(6) <= (FE(9) AND FOFRAME) OR (FE(25) AND TFRAME) OR (SE(6) AND SFRAME) OR (SE(22) AND FFRAME); 
DD(7) <= (FE(10) AND FOFRAME) OR (FE(26) AND TFRAME) OR (SE(7) AND SFRAME) OR (SE(23) AND FFRAME); 
DD(8) <= (SA(0) AND FOFRAME) OR (SE(24) AND TFRAME) OR (FE(0) AND SFRAME) OR (FE(16) AND FFRAME); 
DD(9) <= (SA(1) AND FOFRAME) OR (SE(8) AND TFRAME) OR (FE(1) AND SFRAME) OR (FE(17) AND FFRAME); 
DD(10) <= (SA(2) AND FOFRAME) OR (FE(31) AND TFRAME) OR (FE(2) AND SFRAME) OR (FE(18) AND FFRAME); 
DD(11) <= (SA(3) AND FOFRAME) OR (FE(15) AND TFRAME) OR (FE(3) AND SFRAME) OR (FE(19) AND FFRAME); 
DD(12) <= (SA(4) AND FOFRAME) OR (SE(27) AND TFRAME) OR (FE(4) AND SFRAME) OR (FE(20) AND FFRAME); 
DD(13) <= (SA(5) AND FOFRAME) OR (SA(27) AND TFRAME) OR (FE(5) AND SFRAME) OR (FE(21) AND FFRAME); 
DD(14) <= (SA(6) AND FOFRAME) OR (SE(25) AND TFRAME) OR (FE(6) AND SFRAME) OR (FE(22) AND FFRAME); 
DD(15) <= FFRAME; 

-- LINK 5 -- DONE
DE(0) <= (FF(11) AND FOFRAME) OR (FF(27) AND TFRAME) OR (SF(0) AND SFRAME) OR (SF(16) AND FFRAME); 
DE(1) <= (FF(12) AND FOFRAME) OR (FF(28) AND TFRAME) OR (SF(1) AND SFRAME) OR (SF(17) AND FFRAME); 
DE(2) <= (FF(13) AND FOFRAME) OR (FF(29) AND TFRAME) OR (SF(2) AND SFRAME) OR (SF(18) AND FFRAME); 
DE(3) <= (FF(14) AND FOFRAME) OR (FF(30) AND TFRAME) OR (SF(3) AND SFRAME) OR (SF(19) AND FFRAME); 
DE(4) <= (FF(7) AND FOFRAME) OR (FF(23) AND TFRAME) OR (SF(4) AND SFRAME) OR (SF(20) AND FFRAME); 
DE(5) <= (FF(8) AND FOFRAME) OR (FF(24) AND TFRAME) OR (SF(5) AND SFRAME) OR (SF(21) AND FFRAME); 
DE(6) <= (FF(9) AND FOFRAME) OR (FF(25) AND TFRAME) OR (SF(6) AND SFRAME) OR (SF(22) AND FFRAME); 
DE(7) <= (FF(10) AND FOFRAME) OR (FF(26) AND TFRAME) OR (SF(7) AND SFRAME) OR (SF(23) AND FFRAME); 
DE(8) <= (FA(27) AND FOFRAME) OR (SF(24) AND TFRAME) OR (FF(0) AND SFRAME) OR (FF(16) AND FFRAME); 
DE(9) <= (FA(28) AND FOFRAME) OR (SF(8) AND TFRAME) OR (FF(1) AND SFRAME) OR (FF(17) AND FFRAME); 
DE(10) <= (FA(29) AND FOFRAME) OR (FF(31) AND TFRAME) OR (FF(2) AND SFRAME) OR (FF(18) AND FFRAME); 
DE(11) <= (FA(30) AND FOFRAME) OR (FF(15) AND TFRAME) OR (FF(3) AND SFRAME) OR (FF(19) AND FFRAME); 
DE(12) <= (SA(24) AND FOFRAME) OR (SF(27) AND TFRAME) OR (FF(4) AND SFRAME) OR (FF(20) AND FFRAME); 
DE(13) <= (FA(31) AND FOFRAME) OR (SA(27) AND TFRAME) OR (FF(5) AND SFRAME) OR (FF(21) AND FFRAME); 
DE(14) <= (SA(23) AND FOFRAME) OR (SF(25) AND TFRAME) OR (FF(6) AND SFRAME) OR (FF(22) AND FFRAME); 
DE(15) <= FFRAME; 

-- LINK 6 -- DONE
DF(0) <= (FG(11) AND FOFRAME) OR (FG(27) AND TFRAME) OR (SG(0) AND SFRAME) OR (SG(16) AND FFRAME); 
DF(1) <= (FG(12) AND FOFRAME) OR (FG(28) AND TFRAME) OR (SG(1) AND SFRAME) OR (SG(17) AND FFRAME); 
DF(2) <= (FG(13) AND FOFRAME) OR (FG(29) AND TFRAME) OR (SG(2) AND SFRAME) OR (SG(18) AND FFRAME); 
DF(3) <= (FG(14) AND FOFRAME) OR (FG(30) AND TFRAME) OR (SG(3) AND SFRAME) OR (SG(19) AND FFRAME); 
DF(4) <= (FG(7) AND FOFRAME) OR (FG(23) AND TFRAME) OR (SG(4) AND SFRAME) OR (SG(20) AND FFRAME); 
DF(5) <= (FG(8) AND FOFRAME) OR (FG(24) AND TFRAME) OR (SG(5) AND SFRAME) OR (SG(21) AND FFRAME); 
DF(6) <= (FG(9) AND FOFRAME) OR (FG(25) AND TFRAME) OR (SG(6) AND SFRAME) OR (SG(22) AND FFRAME); 
DF(7) <= (FG(10) AND FOFRAME) OR (FG(26) AND TFRAME) OR (SG(7) AND SFRAME) OR (SG(23) AND FFRAME); 
DF(8) <= (FA(11) AND FOFRAME) OR (SG(24) AND TFRAME) OR (FG(0) AND SFRAME) OR (FG(16) AND FFRAME); 
DF(9) <= (FA(12) AND FOFRAME) OR (SG(8) AND TFRAME) OR (FG(1) AND SFRAME) OR (FG(17) AND FFRAME); 
DF(10) <= (FA(13) AND FOFRAME) OR (FG(31) AND TFRAME) OR (FG(2) AND SFRAME) OR (FG(18) AND FFRAME); 
DF(11) <= (FA(14) AND FOFRAME) OR (FG(15) AND TFRAME) OR (FG(3) AND SFRAME) OR (FG(19) AND FFRAME); 
DF(12) <= (SA(8) AND FOFRAME) OR (SG(27) AND TFRAME) OR (FG(4) AND SFRAME) OR (FG(20) AND FFRAME); 
DF(13) <= (FA(15) AND FOFRAME) OR (SA(27) AND TFRAME) OR (FG(5) AND SFRAME) OR (FG(21) AND FFRAME); 
DF(14) <= (SA(7) AND FOFRAME) OR (SG(25) AND TFRAME) OR (FG(6) AND SFRAME) OR (FG(22) AND FFRAME); 
DF(15) <= FFRAME; 

-- LINK 7 -- DONE
DG(0) <= (FH(11) AND FOFRAME) OR (FH(27) AND TFRAME) OR (SH(0) AND SFRAME) OR (SH(16) AND FFRAME); 
DG(1) <= (FH(12) AND FOFRAME) OR (FH(28) AND TFRAME) OR (SH(1) AND SFRAME) OR (SH(17) AND FFRAME); 
DG(2) <= (FH(13) AND FOFRAME) OR (FH(29) AND TFRAME) OR (SH(2) AND SFRAME) OR (SH(18) AND FFRAME); 
DG(3) <= (FH(14) AND FOFRAME) OR (FH(30) AND TFRAME) OR (SH(3) AND SFRAME) OR (SH(19) AND FFRAME); 
DG(4) <= (FH(7) AND FOFRAME) OR (FH(23) AND TFRAME) OR (SH(4) AND SFRAME) OR (SH(20) AND FFRAME); 
DG(5) <= (FH(8) AND FOFRAME) OR (FH(24) AND TFRAME) OR (SH(5) AND SFRAME) OR (SH(21) AND FFRAME); 
DG(6) <= (FH(9) AND FOFRAME) OR (FH(25) AND TFRAME) OR (SH(6) AND SFRAME) OR (SH(22) AND FFRAME); 
DG(7) <= (FH(10) AND FOFRAME) OR (FH(26) AND TFRAME) OR (SH(7) AND SFRAME) OR (SH(23) AND FFRAME); 
DG(8) <= (FA(23) AND FOFRAME) OR (SH(24) AND TFRAME) OR (FH(0) AND SFRAME) OR (FH(16) AND FFRAME); 
DG(9) <= (FA(24) AND FOFRAME) OR (SH(8) AND TFRAME) OR (FH(1) AND SFRAME) OR (FH(17) AND FFRAME); 
DG(10) <= (FA(25) AND FOFRAME) OR (FH(31) AND TFRAME) OR (FH(2) AND SFRAME) OR (FH(18) AND FFRAME); 
DG(11) <= (FA(26) AND FOFRAME) OR (FH(15) AND TFRAME) OR (FH(3) AND SFRAME) OR (FH(19) AND FFRAME); 
DG(12) <= (SA(27) AND FOFRAME) OR (SH(27) AND TFRAME) OR (FH(4) AND SFRAME) OR (FH(20) AND FFRAME); 
DG(13) <= (SA(26) AND FOFRAME) OR (SA(27) AND TFRAME) OR (FH(5) AND SFRAME) OR (FH(21) AND FFRAME); 
DG(14) <= (SA(25) AND FOFRAME) OR (SH(25) AND TFRAME) OR (FH(6) AND SFRAME) OR (FH(22) AND FFRAME); 
DG(15) <= FFRAME; 

-- LINK 8 -- DONE
DH(0) <= (FI(11) AND FOFRAME) OR (FI(27) AND TFRAME) OR (SI(0) AND SFRAME) OR (SI(16) AND FFRAME); 
DH(1) <= (FI(12) AND FOFRAME) OR (FI(28) AND TFRAME) OR (SI(1) AND SFRAME) OR (SI(17) AND FFRAME); 
DH(2) <= (FI(13) AND FOFRAME) OR (FI(29) AND TFRAME) OR (SI(2) AND SFRAME) OR (SI(18) AND FFRAME); 
DH(3) <= (FI(14) AND FOFRAME) OR (FI(30) AND TFRAME) OR (SI(3) AND SFRAME) OR (SI(19) AND FFRAME); 
DH(4) <= (FI(7) AND FOFRAME) OR (FI(23) AND TFRAME) OR (SI(4) AND SFRAME) OR (SI(20) AND FFRAME); 
DH(5) <= (FI(8) AND FOFRAME) OR (FI(24) AND TFRAME) OR (SI(5) AND SFRAME) OR (SI(21) AND FFRAME); 
DH(6) <= (FI(9) AND FOFRAME) OR (FI(25) AND TFRAME) OR (SI(6) AND SFRAME) OR (SI(22) AND FFRAME); 
DH(7) <= (FI(10) AND FOFRAME) OR (FI(26) AND TFRAME) OR (SI(7) AND SFRAME) OR (SI(23) AND FFRAME); 
DH(8) <= (FA(7) AND FOFRAME) OR (SI(24) AND TFRAME) OR (FI(0) AND SFRAME) OR (FI(16) AND FFRAME); 
DH(9) <= (FA(8) AND FOFRAME) OR (SI(8) AND TFRAME) OR (FI(1) AND SFRAME) OR (FI(17) AND FFRAME); 
DH(10) <= (FA(9) AND FOFRAME) OR (FI(31) AND TFRAME) OR (FI(2) AND SFRAME) OR (FI(18) AND FFRAME); 
DH(11) <= (FA(10) AND FOFRAME) OR (FI(15) AND TFRAME) OR (FI(3) AND SFRAME) OR (FI(19) AND FFRAME); 
DH(12) <= (NEG AND FOFRAME) OR (SI(27) AND TFRAME) OR (FI(4) AND SFRAME) OR (FI(20) AND FFRAME); 
DH(13) <= (NEG AND FOFRAME) OR (SA(27) AND TFRAME) OR (FI(5) AND SFRAME) OR (FI(21) AND FFRAME); 
DH(14) <= (NEG AND FOFRAME) OR (SI(25) AND TFRAME) OR (FI(6) AND SFRAME) OR (FI(22) AND FFRAME); 
DH(15) <= FFRAME; 

END ARC;
